package Maccess;

use strict;

my $pkg="Maccess";

use Maccess_locale;
use Maccess_db;
use Maccess_query_string;
use Meopta;
use DBI;
use CGI;
use Apache::Session::File;
use Date::Calc;
use Unicode::Map8;
use Unicode::String;

#-- definice zakladnich promenych pro komunikaci s SQL servrem
my $driver=Maccess_db->maccess_driver;
my $hostname=Maccess_db->maccess_hostname;
my $dbh=Maccess_db->maccess_dbh;
my $database_test="test"; # jmeno databaze ke ktere se muze pripojit uplne kazdy - vhodne pro SQL prikazy, ktere jiz presne definuji databaze, kterych se tykaji a ja proste jen potrebuji se konektnout k servru

#-- jelikoz se ve funkcich obcas ptam co bylo poslano GETem nebo POSTem definuji zde promenou $query
my $query=new CGI;

#-- Nasledujici 2 radky je treba upravit pro premisteni vyvojove verze na ostrou
my $maccess_ver="Maccess 1.7.10"; # verze Maccessu
# !!! set next line
my $maccess_webpath="/home/wwwi/www";
# !!! set next line
my $maccess_path="/maccess"; # cesta ke stromu maccessu
my $maccess_abspath="$maccess_webpath$maccess_path";
my $maccess_tmp_abspath="/tmp/sessions"; #-- viz poznamky nize
if(!-e($maccess_tmp_abspath)) {
   mkdir($maccess_tmp_abspath,0700);
}
my $maccess_bin_path="$maccess_path/bin"; #-- viz poznamky nize
my $maccess_lib_path="$maccess_path/lib"; #-- $lib_path je tu proto, ze balicek Maccess mohou pouzivat i jine externi programy, ktere jsou umisteny uplne jinde nez maccess a aby pak v nich fungovali odkazy na soubory gif, js, xsl, ..
                                       #-- vsude v Maccess.pm a maccesovskejch phtml programech dusledne pouzivej promenou $lib_path
my $maccess_power_user="chlupm"; # uzivatel, ktery muze ukladat spec. nastaveni i u dotazu, ktere nejsou ulozeny (vhodne u ext. programu uzivajicich Maccess.pm)
my $maccess_query_name_ungroup=" (ungroup)"; # dodatek k nazvu dotazu, ktery vznikl odgrupovanim
my $host_url=$ENV{'SCRIPT_URI'}; $host_url=~s/^(\w*\:\/\/[^\/]+)\/.*$/$1/;
my $maccess_domain=$host_url; $maccess_domain=~s/^.*(\.[^\.]+\.[^\.]+)$/$1/; # vyuziva se pri praci s cookie

#-- definice nekterych klicu uzivanych ve %grid_field
my @grid_field_keys_fixed=('query_name','query_name_class','query_type','database','num_q_tables','num_q_fields','query_group','limit_string','link');
my @grid_field_keys_Table=("name","as","jointype","joinwhere");
my @grid_field_keys_Field=("name","as","group","view","sort","where");

#-- Funkce, ktere vraci obsah nekterych casto pouzivanych promenych
sub maccess_ver { return $maccess_ver; }
sub maccess_path { return $maccess_path; }
sub maccess_tmp_abspath { return $maccess_tmp_abspath; }
sub maccess_lib_path { return $maccess_lib_path; }
sub maccess_power_user { return $maccess_power_user; }
sub maccess_query_name_ungroup { return $maccess_query_name_ungroup; }
sub maccess_domain { return $maccess_domain; }

#--------------- Zaznamenani ruznych nastavenich v cookies --------------------#
# pokud by toho melo byt vic, tak to zmen a do cookies uloz jen nejaky klic a zbytek uloz v ramci nejakych trvalych sessions
sub maccess_settings_create_cookies {
   my @cookies;
   if($query->param("set")) {
      foreach my $name ("language","charset") {
         my $cookie=$query->cookie( -name=>$name, -value=>[$query->param($name)], -domain => $maccess_domain );
         push(@cookies,$cookie);
      }
   }
   return \@cookies;
}

#--------------- Priprava pro spusteni dotazu ze souboru -----------------------#
sub query_file_to_hash {
   my ($pkg_p,$database,$folder,$query_name)=@_;
   my $grid_field;
   my $query_string="
      select
         *
      from
         Query
      where
         Query.database_name=? and
         Query.folder_name=? and
         Query.query_name=?
   ";
   my $sth=$dbh->prepare($query_string);
   my $rv=$sth->execute($database,"$folder",$query_name);
   my $ref=$sth->fetchrow_hashref;
   $grid_field=$ref;
   # radek nize, protoze jsem nemohl v nazvech polozek pouzit slova "database" - jde o nesoulad v nazvech v tabulce a v promenych zde pouzivanych, ale snad to nevadi
   $$grid_field{database}=$$grid_field{database_name}; $$grid_field{folder}=$$grid_field{folder_name};
   my $rc=$sth->finish;
   my $query_string="
      select
         *
      from
         Query_field_attribute
      where
         Query_field_attribute.database_name=? and
         Query_field_attribute.folder_name=? and
         Query_field_attribute.query_name=?
   ";
   my $sth=$dbh->prepare($query_string);
   my $rv=$sth->execute($database,"$folder",$query_name);
   while(my $ref=$sth->fetchrow_hashref) {
      $$grid_field{"Field$$ref{row}_$$ref{field_attribute}"}=$$ref{value};
   }
   my $rc=$sth->finish;
   my $query_string="
      select
         *
      from
         Query_table_attribute
      where
         Query_table_attribute.database_name=? and
         Query_table_attribute.folder_name=? and
         Query_table_attribute.query_name=?
   ";
   my $sth=$dbh->prepare($query_string);
   my $rv=$sth->execute($database,"$folder",$query_name);
   while(my $ref=$sth->fetchrow_hashref) {
      $$grid_field{"Table$$ref{row}_$$ref{table_attribute}"}=$$ref{value};
   }
   my $rc=$sth->finish;
   return $grid_field;
}

#--------------- Nacteni specialnich nastaveni dotazu ------------------------#
sub query_file_spec_to_hash {
   my ($pkg_p,$database,$folder,$query_name,$spec_type,$tagname,$col_number)=@_;
   my %grid_field_spec;
   my $query_string="
      select
         Query_spec_attribute.field_attribute,
         Query_spec_attribute.value
      from
         Query_spec_attribute
      where
         Query_spec_attribute.database_name=? and
         Query_spec_attribute.folder_name=? and
         Query_spec_attribute.query_name=? and
         Query_spec_attribute.query_type=? and
         Query_spec_attribute.field_name=? and
         Query_spec_attribute.field_number like ?
      order by
         Query_spec_attribute.field_number desc,
         Query_spec_attribute.field_attribute asc
   ";
   my $sth=$dbh->prepare($query_string);
   # zkusim napred najit jmeno sloupce na zadane cisle sloupce a pokud nenaleznu zkusim to jeste jednou a jiz bez ohledu na cislo sloupce (pokud jich bude vic budou vzaty hodnoty prvniho sloupce - to diky razeni desc)
   # proste lepsi je, kdyz je jmeno sloupce jednoznacne
   foreach my $col_number ($col_number,"%") {
      my $rv=$sth->execute($database,"$folder","$query_name","$spec_type","$tagname","$col_number");
      my $founded=$sth->rows;
      while(my $ref=$sth->fetchrow_hashref) {
         $grid_field_spec{$$ref{field_attribute}}=$$ref{value};
      }
      my $rc=$sth->finish;
      last if($founded);
   }
   return \%grid_field_spec;
}

#--------------- Priprava pro spusteni dotazu z query mrizky --------------------#
sub query_grid_to_hash {
   my ($pkg_p)=@_;
   my %grid_field;
   foreach my $key (@grid_field_keys_fixed) {
      $grid_field{$key}=$query->param($key);
   }
   for(my $i=0;$i<$grid_field{num_q_fields};++$i) {
      foreach my $field_attribute (@grid_field_keys_Field) {
         $grid_field{"Field${i}_$field_attribute"}=$query->param("Field${i}_$field_attribute");
      }
   }
   for(my $i=0;$i<$grid_field{num_q_tables};++$i) {
      foreach my $table_attribute (@grid_field_keys_Table) {
         $grid_field{"Table${i}_$table_attribute"}=$query->param("Table${i}_$table_attribute");
      }
   }
   # nacteni seznamu tabulek ktere se maji zobrazovat z session
   my $idqc=$query->param('idqc');
   my %session;
   eval { # blok eval zajistuje, ze pokud neexistuje session $idqc, tak nedojde ke zhrouceni programu
      tie %session, "Apache::Session::File", $idqc, {
         Directory => $maccess_tmp_abspath,
         LockDirectory   => $maccess_tmp_abspath
      };
   };
   $grid_field{showtables}=join(",",@{$session{tables}});
   untie %session;
   return \%grid_field;
}

#--------------- Generace hashe navrhu poddotazu z hashe navrhu dotazu
## obdobnou vec delas ve fci Maccess_query_string->query_string_subgrp - casem by meli fce nejak scasti splynout
sub query_hash_to_ungroup_hash {
   my ($pkg_p,$grid_field)=@_;
   my %grid_field_ungroup;
   foreach my $key (@grid_field_keys_fixed) {
      $grid_field_ungroup{$key}=$$grid_field{$key};
   }
   $grid_field_ungroup{query_name}= $grid_field_ungroup{query_name} . $maccess_query_name_ungroup;
   $grid_field_ungroup{query_group}="0";
   for(my $i=0;$i<$$grid_field{num_q_tables};++$i) {
      foreach my $table_attribute (@grid_field_keys_Table) {
         $grid_field_ungroup{"Table${i}_$table_attribute"}=$$grid_field{"Table${i}_$table_attribute"};
      }
   }
   $grid_field_ungroup{"Field0_name"}="*";
   $grid_field_ungroup{"Field0_view"}="1";
   my $j=20;
   for(my $i=0;$i<$$grid_field{num_q_fields};++$i) {
      if($$grid_field{"Field${i}_group"} eq "group") {
         ++$j;
         $grid_field_ungroup{"Field${j}_name"}=$$grid_field{"Field${i}_name"};
         $grid_field_ungroup{"Field${j}_where"}= "=\"[" . $$grid_field{"Field${i}_as"} . ":]\"";
      }
      elsif($$grid_field{"Field${i}_where"}) {
         if($$grid_field{query_group} and $$grid_field{"Field${i}_view"} and ($$grid_field{"Field${i}_as"} or $$grid_field{"Field${i}_group"} ne "expr")) {  # podmiky HAVING neuvazuj
         }
         else {
            ++$j;
            $grid_field_ungroup{"Field${j}_name"}=$$grid_field{"Field${i}_name"};
            $grid_field_ungroup{"Field${j}_where"}=$$grid_field{"Field${i}_where"};
         }
      }
   }
   $grid_field_ungroup{num_q_fields}=$j+1;
   return \%grid_field_ungroup;
}

#--------------- Ulozeni dotazu do souboru -------------------------------------#
sub query_save {
   my ($pkg_p,$folder)=@_;
   my $grid_field=$pkg->query_grid_to_hash();
   print "Content-Type: text/html\n\n";
   print "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"DTD/xhtml1-transitional.dtd\">\n";
   my $create_user_query=$pkg->create_user($$grid_field{database},$folder,$$grid_field{query_name});
   my $create_user_folder=$pkg->create_user($$grid_field{database},$folder);
   my $remote_user=$pkg->get_remote_user;
   # dotaz muze ulozit kdokoliv pokud neexistuje nebo jeho tvurce nebo tvurce slozky
   if((!defined($create_user_query) or ($create_user_query eq $remote_user) or ($create_user_folder eq $remote_user)) and length($$grid_field{query_name})) {
      # ulozeni do Query
      my $query_string="
         replace
            Query
            (database_name, folder_name, query_name, query_name_class, create_user, query_type, query_group, num_q_tables, num_q_fields, limit_string, showtables, link)
         values
            (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
      ";
      my $sth=$dbh->prepare($query_string);
      my $rv=$sth->execute("$$grid_field{database}","$folder","$$grid_field{query_name}","$$grid_field{query_name_class}","$remote_user","$$grid_field{query_type}","$$grid_field{query_group}","$$grid_field{num_q_tables}","$$grid_field{num_q_fields}","$$grid_field{limit_string}","$$grid_field{showtables}","$$grid_field{link}");
      my $rc=$sth->finish;
      # ulozeni do Query_field_attribute
      my $query_string="
         delete from
            Query_field_attribute
         where
            Query_field_attribute.database_name=? and
            Query_field_attribute.folder_name=? and
            Query_field_attribute.query_name=?
      ";
      my $sth=$dbh->prepare($query_string);
      my $rv=$sth->execute("$$grid_field{database}","$folder","$$grid_field{query_name}");
      my $rc=$sth->finish;
      my $query_string="
         replace
            Query_field_attribute
            (database_name, folder_name, query_name, row, field_attribute, value)
         values
            (?, ?, ?, ?, ?, ?)
      ";
      my $sth=$dbh->prepare($query_string);
      for(my $i=0;$i<$$grid_field{num_q_fields};++$i) {
         foreach my $field_attribute (@grid_field_keys_Field) {
            my $value=$$grid_field{"Field${i}_$field_attribute"};
            my $rv=$sth->execute("$$grid_field{database}","$folder","$$grid_field{query_name}","$i","$field_attribute","$value");
            my $rc=$sth->finish;
         }
      }
      # ulozeni do Query_table_attribute
      my $query_string="
         delete from
            Query_table_attribute
         where
            Query_table_attribute.database_name=? and
            Query_table_attribute.folder_name=? and
            Query_table_attribute.query_name=?
      ";
      my $sth=$dbh->prepare($query_string);
      my $rv=$sth->execute("$$grid_field{database}","$folder","$$grid_field{query_name}");
      my $rc=$sth->finish;
      my $query_string="
         replace
            Query_table_attribute
            (database_name, folder_name, query_name, row, table_attribute, value)
         values
            (?, ?, ?, ?, ?, ?)
      ";
      my $sth=$dbh->prepare($query_string);
      for(my $i=0;$i<$$grid_field{num_q_tables};++$i) {
         foreach my $table_attribute (@grid_field_keys_Table) {
            my $value=$$grid_field{"Table${i}_$table_attribute"};
            my $rv=$sth->execute("$$grid_field{database}","$folder","$$grid_field{query_name}","$i","$table_attribute","$value");
            my $rc=$sth->finish;
         }
      }
      $pkg->print_HTML_head(
         $$grid_field{query_name},
         "",
         "class=\"green\"",
         1
      );
      print "<p";
            printA("id","message");
            print ">";
      printE(translate("Query :0 was saved.",$$grid_field{query_name}));
      print "</p>";
      print "<script";
            printA("type","text/javascript");
            print ">";
      print "history.go(-1);";
      print "</script>";
   }
   else {
      $pkg->print_HTML_head(
         $$grid_field{query_name},
         "",
         "class=\"red\"",
         1
      );
      print "<p";
            printA("id","message");
            print ">";
      printE(translate("Query :0 can be changed only by its creator - :1 or by the folder creator - :2.",$$grid_field{query_name},$create_user_query,$create_user_folder));
      print "</p>";
   }
   $pkg->print_HTML_foot(
      $$grid_field{database},
      $folder
   );
   return 1;
}

#-----------------------------
sub to_sql {
   my ($pkg_p,$grid_field_p)=@_;
   my %grid_field=%$grid_field_p;
   my %query_hash;
   $query_hash{LIMIT}=$grid_field{limit_string};
   my $order_string_xml_group="";
   my @cols_maccess_type;
   for(my $i=0;$i<$grid_field{num_q_tables};++$i) {
      if(my $Table_name=      $grid_field{ "Table${i}_name" }) {
         my $Table_as=        $grid_field{ "Table${i}_as" };
         my $Table_jointype=  $grid_field{ "Table${i}_jointype" };
         my $Table_joinwhere= $grid_field{ "Table${i}_joinwhere" };
         if($Table_jointype) {
            $query_hash{FROM}.=" $Table_jointype ";
         }
         $query_hash{FROM}.=$Table_name;
         if($Table_as) {
            $query_hash{FROM}.=" as $Table_as";
         }
         if($Table_joinwhere) {
            $query_hash{FROM}.=" on ($Table_joinwhere)";
         }
      }
   }
   my $j=-1;
   for(my $i=0;$i<$grid_field{num_q_fields};++$i) {
      if(my $Field_name=   $grid_field{ "Field${i}_name" }) {
         my $Field_group=  $grid_field{ "Field${i}_group" };
         my $Field_as=     $pkg->encode_maccess($grid_field{ "Field${i}_as" });
         my $Field_view=   $grid_field{ "Field${i}_view" };
         my $Field_sort=   $grid_field{ "Field${i}_sort" };
         my $Field_where=  $grid_field{ "Field${i}_where" };
         if($Field_sort eq "xml_group") { #- zajisteni, ze pri $Field_sort eq 'xml_group' je vlastne jakoby vzdy zatrzeno Zobr. -> je dulezite, aby ve vystupu byl sloupec, kde ktereho je xml_group
            $Field_view=1;
         }
         if($grid_field{query_group} and !(($Field_group eq "group") or ($Field_group eq "expr"))) {
            $Field_name="$Field_group($Field_name)";
         }
         else {
            $Field_name=$grid_field{"Field${i}_name"};
         }
         if($Field_view or ($Field_group eq "group")) {
            ++$j;
            if($Field_as) {
               $query_hash{COLS}.=$Field_name." as ".$Field_as.", ";
            }
            else {
               $query_hash{COLS}.=$Field_name.", ";
            }
            #- urceni typu sloupce v maccessu
            if(!$Field_view) {
               $cols_maccess_type[$j]="hidden_group";
            }
            elsif($Field_sort eq "xml_group" and $grid_field{query_type}!~/^update/) {
               $cols_maccess_type[$j]="xml_group";
            }
            elsif($Field_sort eq "style") {
               $cols_maccess_type[$j]="style";
            }
            elsif($Field_sort eq "href") {
               $cols_maccess_type[$j]="href";
            }
            else {
               $cols_maccess_type[$j]="value";
            }

         }
         if($Field_where) {
            if($grid_field{query_group} and $Field_view and ($Field_as or $Field_group ne "expr")) { # pripadna zmena v teto podmince se musi promitnout i ve funkci query_hash_to_ungroup_hash
               $query_hash{HAVING}.=Maccess_query_string->modify_Field_where($Field_where, $Field_as || $Field_name)." and ";
            }
            else {
               $query_hash{WHERE}.="(".Maccess_query_string->modify_Field_where($Field_where,$Field_name).") and ";
            }
         }
         if($grid_field{query_group} and ($Field_group eq "group")) {
            if($Field_as) {
               $query_hash{"GROUP BY"}.=$Field_as.",";
            }
            else {
               # zmena - pozor predpokladam, ze je jedinecne pojmenovan - jinak je treba upravit query_string_subgrp
               # $query_hash{"GROUP BY"}.=$Field_name.",";
               die encode_entities(translate("Column :0 must be named in box \"as\".",$Field_name));
            }
         }
         if($Field_sort) {
            if($Field_as and ($Field_sort eq "asc" or $Field_sort eq "desc")) {
               $query_hash{"ORDER BY"}.=$Field_as." ".$Field_sort.",";
            }
            elsif($Field_sort eq "asc" or $Field_sort eq "desc") {
               $query_hash{"ORDER BY"}.=$Field_name." ".$Field_sort.",";
            }
            elsif($Field_as and $Field_sort eq "xml_group") {
               $order_string_xml_group.=$Field_as." asc,";
            }
            elsif($Field_sort eq "xml_group") {
               $order_string_xml_group.=$Field_name." asc,";
            }
         }
      }
   }
   $query_hash{COLS}=substr($query_hash{COLS},0,length($query_hash{COLS})-2); # rezu ", "
   $query_hash{WHERE}=substr($query_hash{WHERE},0,length($query_hash{WHERE})-5); # rezu " and "
   $query_hash{"GROUP BY"}=substr($query_hash{"GROUP BY"},0,length($query_hash{"GROUP BY"})-1); # rezu ","
   $query_hash{HAVING}=substr($query_hash{HAVING},0,length($query_hash{HAVING})-5); # rezu " and "
   $query_hash{"ORDER BY"}=$order_string_xml_group.$query_hash{"ORDER BY"};
   $query_hash{"ORDER BY"}=substr($query_hash{"ORDER BY"},0,length($query_hash{"ORDER BY"})-1); # rezu ","
   my $query_string=Maccess_query_string->query_hash_to_query_string(\%query_hash);
   my %param;
   $param{database}=$grid_field{database};
   $param{folder}=$grid_field{folder};
   $param{query_name}=$grid_field{query_name};
   $param{query_group}=$grid_field{query_group};
   $param{query_type}=$grid_field{query_type};
   $param{query_string}=$query_string;
   $param{link}=$grid_field{link};
   $param{cols_maccess_type}=\@cols_maccess_type;
   return (\%param);
}


#--------------- Obsahuje-li retezec "promene - [Promena:hodnota]" bude vytvoren formular -----------#
sub query_form {
   my ($pkg_p,$param,$from_query_file)=@_;
   # Funkce prevalcuje nektere hodnoty v param, pokud prisli primo GET ci POST metodou v pozadavku
   $param=$pkg->update_param_by_GET_or_POST($param);
   my ($database,$folder,$query_name,$query_string)=($$param{database},$$param{folder},$$param{query_name},$$param{query_string});
   print "Content-Type: text/html\n\n";
   print "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"DTD/xhtml1-transitional.dtd\">\n";
   $pkg->print_HTML_head(
      $query_name,
      "
         <script type=\"text/javascript\" src=\"" . encode_entities(encode_uri("$maccess_lib_path/focusFirstBox.js")). "\"></script>
      ",
      "onload=\"focusFirstBox()\"",
      1
   );
   print "<form";
         printA("action","do.phtml");
         printA("method","get");
         print ">";
   print "<div>";
   # dotaz je spusten "ze souboru"
   if($from_query_file) {
      $pkg->print_basic_input_hidden($database,$folder,$query_name);
   }
   # dotaz je neni spusten "ze souboru"
   else {
      # zaznamenani udaju v param do souboru
      my $id=$pkg->param_save($param);
      print "<input";
            printA("type","hidden");
            printA("name","id");
            printA("value",$id);
            print "/>";
   }
   print "<table";
         printA("cellpadding","5px");
         print ">";
   ## zadna krasavice - obdaba viz tez Maccess_query_string->insert_values_to_query_string
   my @query_string_split=split(/\[([^\]:]+:[^\]]*)\]/si,$query_string);
   my @variables;
   for(my $i=1;$i<=$#query_string_split;$i+=2) {
      my @variable=split(/:/si,$query_string_split[$i],2);
      if(!grep(/^\Q$variable[0]\E$/, @variables)) {
         push(@variables,$variable[0]);
         print "<tr>";
         print "<td>";
         printE("$variable[0]: ");
         print "</td>";
         print "<td>";
         if($variable[1]=~/^SELECT /si) {
            $pkg->print_select_menu_q($variable[0],$variable[1],$database);
         }
         elsif($variable[1]=~/\|/si) {
            $pkg->print_select_menu($variable[0],$variable[1]);
         }
         else {
            print "<input";
                  printA("name","VAR_$variable[0]");
                  printA("type","text");
                  printA("value",$variable[1]);
                  print "/>";
         }
         print "</td>";
         print "</tr>";
      }
   }
   print "<tr>";
   print "<td";
         printA("colspan","2");
         print ">";
   print "<input";
         printA("type","submit");
         printA("value",translate("Run"));
         print "/>";
   print "</td>";
   print "</tr>";
   print "</table>";
   print "<p";
         printA("style","font-style: italic; margin-top: 60px;");
         print ">";
   # query_type
   printE(translate("Output:"));
   printE(" ");
   $pkg->print_select_query_type($$param{query_type});
   print "</p>";
   # link
   print "<input";
         printA("type","hidden");
         printA("name","link");
         printA("value",$$param{link});
         print "/>";
   # form_do - po nasledujicim submi jde o informaci, ze dotaz byl spusten z formulare
   print "<input";
         printA("type","hidden");
         printA("name","form_do");
         printA("value","1");
         print "/>";
   print "</div>";
   print "</form>";
   $pkg->print_HTML_foot($database,$folder);
   return 1;
}

#-------------- Formular zobrazujici query_string retezec pro "select" dotaz ---#
sub query_string_print {
   my ($pkg_p,$param)=@_;
   # zaznamenani udaju v param do souboru
   my $id=$pkg->param_save($param);
   my ($database,$folder,$query_name,$query_string)=($$param{database},$$param{folder},$$param{query_name},$$param{query_string});
   print "Content-Type: text/html\n\n";
   print "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"DTD/xhtml1-transitional.dtd\">\n";
   $pkg->print_HTML_head(
      $query_name,
      "",
      "",
      1
   );
   print "<form";
         printA("name","Query_Select");
         printA("action","do.phtml");
         printA("method","post");
         print ">";
   print "<p>";
   print "<input";
         printA("type","hidden");
         printA("name","id");
         printA("value","$id");
         print "/>";
   print "<textarea";
         printA("name","query_string");
         printA("rows","15");
         printA("cols","70");
         print ">";
   printE($query_string);
   print "</textarea>";
   print "</p>";
   print "<p>";
   print "<input";
         printA("name","viewSQL_do");
         printA("type","submit");
         printA("value",translate("Run"));
         print "/>";
   print "</p>";
   print "</form>";
   print "<p>";
   print "<b>";
   printE("SELECT syntax:");
   print "</b>";
   print "</p>";
   print "<pre>";
   printE("
      SELECT
         select_expression,...
         [FROM table_references
            [WHERE where_definition]
            [GROUP BY {unsigned_integer | col_name | formula}]
            [HAVING where_definition]
            [ORDER BY {unsigned_integer | col_name | formula} [ASC | DESC] ,...]
            [LIMIT [offset,] rows]
   ");
   print "</pre>";
   print "<p>";
   print "<b>";
   printE("JOIN syntax:");
   print "</b>";
   print "</p>";
   print "<pre>";
   printE("
      table_reference INNER JOIN table_reference ON conditional_expr
      table_reference LEFT OUTER JOIN table_reference ON conditional_expr
   ");
   print "</pre>";
   $pkg->print_HTML_foot($database,$folder);
   return 1;
}

#--------------- Odeslani pozadavku SQL serveru a zobrazeni vysledku -----------#
sub query_to_array {
   my ($pkg_p,$param)=@_;
   my ($database,$folder,$query_name,$query_group,$query_type,$query_string)=($$param{database},$$param{folder},$$param{query_name},$$param{query_group},$$param{query_type},$$param{query_string});
   #-- Jestlize neexistuje limit, pak bude pridelen - dulezite u dotazu vzniklych pri ungroup
   my ($query_string_no_limit, @limit)=Maccess_query_string->query_string_no_limit($query_string);
   if(!@limit) {
      @limit=(0,500);
      my $query_hash=Maccess_query_string->query_string_to_query_hash($query_string);
      $$query_hash{LIMIT}=join(",",@limit);
      $query_string=Maccess_query_string->query_hash_to_query_string($query_hash);
   }
   my @cols_maccess_type;
   if(defined($$param{cols_maccess_type})) {
      @cols_maccess_type=@{$$param{cols_maccess_type}};
   }
   # zaznamenani udaju v param do souboru
   my $id=$pkg->param_save($param);
   my (@data,@cols);
   my ($limit,%cross_ref,$hidden);
   my ($user,$pass)=$pkg->user_sql($pkg->get_remote_user());
   my $dbh_user=DBI->connect("DBI:$driver:$database:$hostname",$user,$pass) || die "DBI connect error";
   my $sth=$dbh_user->prepare(Maccess_query_string->convert_some_strings($query_string));
   my $error;
   eval {
      local $SIG{__WARN__}=sub { $error=$_[0]; };
      my $rv=$sth->execute;
   };
   #---- spusteni dotazu selhalo - nejspis jde o chybnou synaxy
   if(defined($error)) {
      $pkg->print_error_syntax($param,$error);  # tiskne kompletni HTML stranku
      $dbh_user->disconnect;
      exit;
   }
   my $num_rows=$sth->rows;
   my $names=$sth->{NAME};
   my $names_type=$sth->{TYPE};
   my $num_fields=$sth->{NUM_OF_FIELDS};
   my $icon;
   #---- nejde o krizovy dotaz
   if($query_group!=2) {
      my @cols_group;
      if($$param{link} eq "no") {
         $icon=0 ;
      }
      else {
         $icon=1;
         @cols_group=Maccess_query_string->query_string_cols_group($query_string);
      }
      #- typ linku
      if(($query_type eq "xml_table" or $query_type eq "table") and Maccess_query_string->may_be_ungroup_query($query_string,$database) and $icon) {    ##--- $query_string=~/ group by /i - zduvodu, ze Maccess zatim umi rozbalovat jen souhrny dotaz pokud obsahuje group by
         $icon=1;
         $cols[0]{name}="+";  # ungroup
         $cols[0]{tagname}=$pkg->encode_tagname("icon");
         $cols[0]{type}="";
         $cols[0]{chosen}="9";  # zajisti, ze sloupec ikon bude v class="chosen9" - a nebude videt pri tisku
      }
      elsif(($query_type eq "xml_table" or $query_type eq "table") and $icon) { ## vyrazeno:  and Maccess_query_string->may_be_update_query($query_string,$database) ## fce may_be_update_query castecne zajistuje detekci zda je mozne pouzit update dotaz - ovsem nemus fungovat dobre, pokud spojeni probiha na zaklade vyrazu jako substring
         $icon=1;
         $cols[0]{name}="#";  # update
         $cols[0]{tagname}=$pkg->encode_tagname("icon");
         $cols[0]{type}="";
         $cols[0]{chosen}="9";  # zajisti, ze sloupec ikon bude v class="chosen9" - a nebude videt pri tisku
      }
      else {
         $icon=0;
      }
      #- zjisteni presnych jmen sloupcu v tabulkach ve tvaru database.table.col
      my @cols_sqlname=Maccess_query_string->query_string_cols_simple($query_string,$database);
      #- zjisteni jmen sloupcu jejichz hodnoty jsou diky spojeni identicke s jinymi
      my ($cols_sqljoin)=Maccess_query_string->query_string_cols_join($query_string,$database);
      #- zjisteni jmen sloupcu, ktere jsou primarnimi klici pro tabulky, ktere jsou v $query_string
      my @cols_prikey_all=Maccess_query_string->query_string_primary_keys($query_string,$database);
      my @cols_prikey; # seznam primarnich klicu, ktere jsou zobrazovany
      my $col=$icon-1;
      for(my $col_sql=0;$col_sql<$num_fields;++$col_sql) {
         if($cols_maccess_type[$col_sql] ne "style" and $cols_maccess_type[$col_sql] ne "href" and $cols_maccess_type[$col_sql] ne "hidden_group") {
            ++$col;
            $cols[$col]{name}=$pkg->decode_maccess($$names[$col_sql]);
            $cols[$col]{tagname}=$pkg->encode_tagname($cols[$col]{name});
            $cols[$col]{type}=$pkg->field_type($$names_type[$col_sql]);
            if(defined($cols_sqlname[$col_sql])) {
               $cols[$col]{sqlname}=$cols_sqlname[$col_sql];
               if(grep(/^\Q$cols[$col]{sqlname}\E$/,@cols_prikey_all)) {
                  $cols[$col]{prikey}=1;
                  push(@cols_prikey,$cols[$col]{sqlname});
               }
               $cols[$col]{sqljoin}=$$cols_sqljoin{$cols[$col]{sqlname}};
               $cols[$col]{sqltype}=$pkg->field_sqltype_by_col_fullname($cols[$col]{sqlname});
               $cols[$col]{length}=$pkg->field_length($cols[$col]{sqlname});
            }
            if($cols_maccess_type[$col_sql] eq "xml_group") {
               $cols[$col]{xml_group}=1;
            }
         }
      }
      #- zjisteni, ktere tabulky v $query_string obsahuji vsechny primarni klice, a tedy jejichz polozky mohou byt aktualizovany
      my @tables_fullname_maybeupdate=$pkg->tables_maybeupdate(@cols_prikey);
      #- pridani pripadne znacky ke jmenu sloubce, ze muze byt aktualizovan
      for(my $col=0;$col<=$#cols;++$col) {
         if($cols[$col]{sqlname}=~/^([^\.]+)\.([^\.]+)\.([^\.]+)$/) {
            my $table_fullname="$1.$2";
            if(grep(/^\Q$table_fullname\E$/,@tables_fullname_maybeupdate)) {
               $cols[$col]{update}="1";
            }
         }
      }
      my $row=0;
      while(my $ref=$sth->fetchrow_arrayref) {
         my (%names_hash);
         my $col=$icon-1;
         for(my $col_sql=0;$col_sql<$num_fields;++$col_sql) {
            if($cols_maccess_type[$col_sql] ne "style" and $cols_maccess_type[$col_sql] ne "href" and $cols_maccess_type[$col_sql] ne "hidden_group") {
               ++$col;
               $data[$row][$col]{value}=$$ref[$col_sql];
            }
            elsif($cols_maccess_type[$col_sql] eq "style") {
               $data[$row][$col]{style}=$$ref[$col_sql];
            }
            elsif($cols_maccess_type[$col_sql] eq "href") {
               $data[$row][$col]{href}=$$ref[$col_sql];
            }
            $names_hash{$$names[$col_sql]}=$$ref[$col_sql];
         }
         if($icon) {
            my $href="do.phtml?";
            $href.="id=";
            $href.=encode_uri($id);
            # ungroup
            if($cols[0]{name} eq "+") {
               my $ungroup_by=$pkg->ungroup_by(\@cols_group,\%names_hash);
               $href.="&ungroup_by=";
               $href.=encode_uri($ungroup_by);
            }
            # update
            elsif($cols[0]{name} eq "#") {
               my $record=$row+$limit[0];
               $href.="&update_record=";
               $href.=encode_uri($record);
            }
            $data[$row][0]{value}="<xhtml>";
            $data[$row][0]{value}.="<img";
            $data[$row][0]{value}.=" border=";
            $data[$row][0]{value}.="\"";
            $data[$row][0]{value}.=encode_entities("0");
            $data[$row][0]{value}.="\"";
            $data[$row][0]{value}.=" alt=";
            $data[$row][0]{value}.="\"";
            $data[$row][0]{value}.=encode_entities($cols[0]{name});
            $data[$row][0]{value}.="&#160;".encode_entities("(" . ($row+1) . ")");
            $data[$row][0]{value}.="\"";
            $data[$row][0]{value}.=" src=";
            $data[$row][0]{value}.="\"";
            $data[$row][0]{value}.=encode_entities(encode_uri("$maccess_lib_path/$cols[0]{name}.gif"));
            $data[$row][0]{value}.="\"";
            $data[$row][0]{value}.="/>";
            $data[$row][0]{value}.="</xhtml>";
            $data[$row][0]{href}=$href;
         }
         ++$row;
      }
      #-limit
      if($limit[1] and ($row>=$limit[1])) {
         $limit=\@limit;
      }
   }
   #---- jde o krizovy dotaz
   else {
      my @cols_group;
      if($$param{link} eq "no") {
         $icon=0 ;
      }
      else {
         $icon=1;
         @cols_group=Maccess_query_string->query_string_cols_group($query_string);
      }
      my (@row_names,@col_names,%col_names_sql,%col_names_sql2,%col_names_type);
      # zjisteni nazvu budoucich sloupcu a nazvu radku a preskupeni hodnot
      my $num_fields_maccess_type_value=0;   # zjisteni skutecnych sloupcu ruznych hodnot
      for(my $col_sql=2;$col_sql<$num_fields;++$col_sql) {
         if($cols_maccess_type[$col_sql] eq "value") {
            ++$num_fields_maccess_type_value;
         }
      }
      my $row=0;
      while(my $ref=$sth->fetchrow_arrayref) {
         my (%names_hash);
         $names_hash{$$names[0]}=$$ref[0];
         $names_hash{$$names[1]}=$$ref[1];
         push(@row_names,$$ref[1]) if(!grep(/^\Q$$ref[1]\E$/, @row_names));
         my ($col_name);
         for(my $col_sql=2;$col_sql<$num_fields;++$col_sql) {
            if($cols_maccess_type[$col_sql] ne "style" and $cols_maccess_type[$col_sql] ne "href" and $cols_maccess_type[$col_sql] ne "hidden_group") {
               if($num_fields_maccess_type_value>1) {
                  $col_name="<xhtml>";
                  $col_name.=encode_entities($$ref[0]);
                  $col_name.="<br/>";
                  $col_name.=encode_entities($pkg->decode_maccess($$names[$col_sql]));
                  $col_name.="</xhtml>";
               }
               else {
                  $col_name="<xhtml>";
                  $col_name.=encode_entities($$ref[0]);
                  $col_name.="</xhtml>";
               }
               push(@col_names,$col_name) if(!grep(/^\Q$col_name\E$/, @col_names));
               $col_names_sql{$col_name}=$pkg->decode_maccess($$names[$col_sql]);
               $col_names_sql2{$col_name}=$$ref[0];
               $col_names_type{$col_name}=$$names_type[$col_sql];
               $cross_ref{$$ref[1]}{$col_name}{value}=$$ref[$col_sql];
            }
            elsif($cols_maccess_type[$col_sql] eq "style") {
               $cross_ref{$$ref[1]}{$col_name}{style}=$$ref[$col_sql];
            }
            elsif($cols_maccess_type[$col_sql] eq "href") {
               $cross_ref{$$ref[1]}{$col_name}{href}=$$ref[$col_sql];
            }
            $names_hash{$$names[$col_sql]}=$$ref[$col_sql];
            # ungroup
            if(!$cross_ref{$$ref[1]}{$col_name}{href} and $icon) {
               my $href="do.phtml?";
               $href.="id=";
               $href.=encode_uri($id);
               my $ungroup_by=$pkg->ungroup_by(\@cols_group,\%names_hash);
               $href.="&ungroup_by=";
               $href.=encode_uri($ungroup_by);
               $cross_ref{$$ref[1]}{$col_name}{href}=$href;
            }
         }
         ++$row;
      }
      @col_names=sort @col_names;
      @row_names=sort @row_names;
      $cols[0]{name}=$pkg->decode_maccess($$names[1]);
      $cols[0]{tagname}=$pkg->encode_tagname($cols[0]{name});
      $cols[0]{type}=$pkg->field_type($$names_type[1]);
      my $col=1;
      foreach my $col_name (@col_names) {
         $cols[$col]{name}=$col_name;
         if($num_fields_maccess_type_value>1) {
            $cols[$col]{tagname}=$pkg->encode_tagname("$col_names_sql2{$col_name} $col_names_sql{$col_name}");
         }
         else {
            $cols[$col]{tagname}=$pkg->encode_tagname($col_names_sql2{$col_name});
         }
         $cols[$col]{name_sql}=$col_names_sql{$col_name};
         $cols[$col]{type}=$pkg->field_type($col_names_type{$col_name});
         ++$col;
      }
      # pridani nazvu budoucich sloupcu Suma
      if($query_type!~/^graph/) { # nepripojuj v pravo sumu pokud jde o graf
         my $korekce=0;
         my $col=0;
         foreach my $col_name (@col_names) {
            ++$col;
            my $modulo=(($col-1) % $num_fields_maccess_type_value);
            if($modulo==0) { # dalsi sada sloupcu
               $korekce=0;
            }
            if($cols[$col]{type} eq "number") {
               my $names_sum="<xhtml>";
               $names_sum.="&#931;";
               if($num_fields_maccess_type_value>1) {
                  $names_sum.="<br/>";
                  $names_sum.=$cols[$col]{name_sql};
               }
               $names_sum.="</xhtml>";
               $cols[1+$#col_names+1+$modulo+$korekce]{name}=$names_sum;
               $cols[1+$#col_names+1+$modulo+$korekce]{tagname}=$pkg->encode_tagname("SUM($cols[$col]{name_sql})");
               $cols[1+$#col_names+1+$modulo+$korekce]{type}=$cols[$col]{type};
            }
            else {
               --$korekce;
            }
         }
      }
      # zaznamenani preskupenych dat, pocitani a zaznamenani sumy
      my $row=0;
      foreach my $row_name (@row_names) {
         my $korekce=0;
         my $col=0;
         $data[$row][$col]{value}=$row_name;
         my @col_sum=();
         foreach my $col_name (@col_names) {
            ++$col;
            $data[$row][$col]{value}=$cross_ref{$row_name}{$col_name}{value};
            $data[$row][$col]{style}=$cross_ref{$row_name}{$col_name}{style};
            $data[$row][$col]{href}=$cross_ref{$row_name}{$col_name}{href};
            my $modulo=(($col-1) % $num_fields_maccess_type_value);
            if($modulo==0) { # dalsi sada sloupcu
               $korekce=0;
            }
            if($cols[$col]{type} eq "number") {
              $data[$row][1+$#col_names+1+$modulo+$korekce]{value}+=$cross_ref{$row_name}{$col_name}{value};
            }
            else {
               --$korekce;
            }
         }
         ++$row;
      }
   }
   my $rc=$sth->finish;
   my $rc=$dbh_user->disconnect;
   return (\@cols,\@data,$id,$limit);
}

#= ------------- Odeslani pozadavku SQL serveru a zobrazeni vysledku --------- =#
sub query_print {
   my ($pkg_p,$param)=@_;
   # Funkce prevalcuje nektere hodnoty v param, pokud prisli primo GET ci POST metodou v pozadavku
   $param=$pkg->update_param_by_GET_or_POST($param);
   # Spusteni prislusne fce dle hodnoty $$param{query_type}
   if($$param{query_type} eq "auto" or !$$param{query_type}) {
      $$param{query_type}=$pkg->query_type_auto($$param{query_string});
   }
   if($$param{query_type}=~/^graph/) {
      $pkg->query_print_graph($param);
   }
   elsif($$param{query_type}=~/^map/) {
      $pkg->query_print_map($param);
   }
   elsif($$param{query_type} eq "update") {
      my ($query_string_no_limit, @limit)=Maccess_query_string->query_string_no_limit($$param{query_string});
      if($limit[1]!=1) {
         my $query_hash=Maccess_query_string->query_string_to_query_hash($$param{query_string});
         $$query_hash{LIMIT}="1";
         $$param{query_string}=Maccess_query_string->query_hash_to_query_string($query_hash);
      }
      $pkg->query_print_xml_table($param);
   }
   elsif($$param{query_type} eq "update_add") {
      my $query_hash=Maccess_query_string->query_string_to_query_hash($$param{query_string});
      undef($$query_hash{WHERE});
      undef($$query_hash{"GROUP BY"});
      undef($$query_hash{HAVING});
      undef($$query_hash{'ORDER BY'});
      $$query_hash{LIMIT}="1";
      $$param{query_string}=Maccess_query_string->query_hash_to_query_string($query_hash);
      $pkg->query_print_xml_table($param);
   }
   else {
      $pkg->query_print_xml_table($param);
   }
}

#= ------------- Zobrazeni ve forme GRAF ------------------------------------- =#
sub query_print_graph {
   my ($pkg_p,$param)=@_;
   # zaznamenani udaju v param do souboru
   my $id=$pkg->param_save($param);
   my ($database,$folder,$query_name,$query_type)=($$param{database},$$param{folder},$$param{query_name},$$param{query_type});
   print "Cache-Control: no-store\n";
   print "Content-Type: text/html\n\n";
   print "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"DTD/xhtml1-transitional.dtd\">\n";
   $pkg->print_HTML_head(
      $query_name,
      "",
      "",
      1
   );
   $pkg->print_variables($$param{variables});
   # samotny obrazek grafu
   print "<p>";
   my $img_src="do.phtml?";
   $img_src.="id=";
   $img_src.=encode_uri($id);
   $img_src.="&graph_gif=";
   $img_src.=encode_uri("1");
   print "<img";
         printA("src",$img_src);
         print ">";
   print "</p>";
   # spec nastaveni - ukladani pro graf
   my $grid_field_spec=$pkg->query_file_spec_to_hash($database,$folder,$query_name,$query_type,"","");
   print "<div";
         printA("class","button");
         print ">";
   print "<b>";
   printE(translate("Spec. settings:"));
   print "</b>";
   print "<br/>";
   print "<form";
         printA("method","post");
         printA("action","$maccess_bin_path/spec_save_graph.phtml");
         print ">";
   $pkg->print_basic_input_hidden($database,$folder,$query_name,$query_type);
   if($query_type ne "graph_pie") {
      printE(translate("y min:"));
      printE(" ");
      print "<input";
            printA("name","min_val");
            printA("type","text");
            printA("size","6");
            printA("value",$$grid_field_spec{min_val});
            print "/>";
      print "&#160;";
      printE(translate("y max:"));
      printE(" ");
      print "<input";
            printA("name","max_val");
            printA("type","text");
            printA("size","6");
            printA("value",$$grid_field_spec{max_val});
            print "/>";
      print "&#160;";
      printE(translate("divide y:"));
      printE(" ");
      print "<input";
            printA("name","y_ticks");
            printA("type","text");
            printA("size","6");
            printA("value",$$grid_field_spec{y_ticks});
            print "/>";
      print "&#160;";
      print "<input";
            printA("type","submit");
            printA("value",translate("save spec. settings"));
            print "/>";
   }
   print "</form>";
   print "</div>";
   $pkg->print_HTML_foot($database,$folder);
   return 1;
}

#= ------------- Zobrazeni ve forme GRAF - print gifu ------------------------ =#
sub query_print_graph_gif {
   my ($pkg_p,$param)=@_;
   my ($cols,$data)=$pkg->query_to_array($param);
   my ($database,$folder,$query_name,$query_type)=($$param{database},$$param{folder},$$param{query_name},$$param{query_type});
   my $num_rows=@$data;
   my $num_fields=@$cols;
   my $graph_x_label=$$cols[0]{tagname};
   if(Maccess_locale->charset eq "windows-1250") { ## typicky ceska zalezitost
      $query_name=$pkg->recode_charset($query_name,"windows-1250","iso-8859-2");
      $graph_x_label=$pkg->recode_charset($graph_x_label,"windows-1250","iso-8859-2");
   }
   my $legend_length=1;
   my @graph_legend;
   for(my $i=1;$i<$num_fields;$i++) {
      $graph_legend[$i-1]=$$cols[$i]{tagname};
      if(Maccess_locale->charset eq "windows-1250") { ## typicky ceska zalezitost
         $graph_legend[$i-1]=$pkg->recode_charset($graph_legend[$i-1],"windows-1250","iso-8859-2");
      }
      $legend_length=length($$cols[$i]{tagname}) if($legend_length<length($$cols[$i]{tagname}));
   }
   my $labels_length=1;
   my $row=0;
   my @graph_data;
   while($row<$num_rows) {
      $graph_data[0] [$row] = $$data[$row][0]{value};
      if(Maccess_locale->charset eq "windows-1250") { ## typicky ceska zalezitost
         $graph_data[0] [$row] = $pkg->recode_charset($graph_data[0] [$row],"windows-1250","iso-8859-2");
      }
      $labels_length=length($$data[$row][0]{value}) if($labels_length<length($$data[$row][0]{value}));
      for(my $i=1;$i<$num_fields;++$i) {
         $graph_data[$i] [$row] = $$data[$row][$i]{value};
      }
      ++$row;
   }
   my $labels_numbers=$num_rows;
   # do grafu se na osu x vleze asi 90 pismenek, chtel bych maximalne asi jen (90/label_lenght) labelu (popisek osy x)
   my $lebels_max_letters=80; # je to fakt viladeno jak na 2pismenovejch popiskach tak i na dlouhejch
   $lebels_max_letters-=$legend_length;  # v pravo zobrazujes legendy y-novych hodnot a ty mohou mit promenou delku  # pokud jde o hodnoty na ose y predpokladam, ze nejsou prilis dlouhe ale nejak o tom neuvazuji
   # Za urcitych podminek tiskni popisky osy x vertikalne
   my $graph_x_labels_style="normal";
   my $graph_x_labels_skip;
   if(($labels_length>=5) && ($labels_length<=15) && (($labels_length*$labels_numbers)>$lebels_max_letters)) {
      $graph_x_labels_style="vertical";
      $graph_x_labels_skip=int( 2.5*$labels_numbers / $lebels_max_letters ) + 1;  # rekneme, ze pismenko je 2.5 krat vyssi nez sirsi
   }
   else {
      $graph_x_labels_skip=int( $labels_length*$labels_numbers / $lebels_max_letters ) + 1;
   }
   my ($gifx,$gify)=(650,400);
   # nacteni spec nastaveni
   my $grid_field_spec=$pkg->query_file_spec_to_hash($database,$folder,$query_name,$query_type,"","");
   my $my_graph;
   if($query_type eq "graph_bars") {
      require Chart::Bars;
      $my_graph=Chart::Bars->new($gifx,$gify);
      $my_graph->set("legend_labels" => \@graph_legend);
      $my_graph->set("x_label"=>$graph_x_label);
      $my_graph->set("title"=>$query_name);
      $my_graph->set("grid_lines"=>"true");
      $my_graph->set("colors"=>{"x_grid_lines" => [225,225,225]});
      $my_graph->set("x_ticks"=> $graph_x_labels_style);
      $my_graph->set("skip_x_ticks"=> $graph_x_labels_skip);
      $my_graph->set("min_val"=>$$grid_field_spec{min_val}) if(length($$grid_field_spec{min_val}));
      $my_graph->set("max_val"=>$$grid_field_spec{max_val}) if(length($$grid_field_spec{max_val}));
      $my_graph->set("y_ticks"=>($$grid_field_spec{y_ticks}+1)) if(length($$grid_field_spec{y_ticks}));
      $my_graph->cgi_png(\@graph_data);
   }
   elsif($query_type eq "graph_bars_sum") {
      require Chart::StackedBars;
      $my_graph=Chart::StackedBars->new($gifx,$gify);
      $my_graph->set("legend_labels" => \@graph_legend);
      $my_graph->set("x_label"=>$graph_x_label);
      $my_graph->set("title"=>$query_name);
      $my_graph->set("grid_lines"=>"true");
      $my_graph->set("colors"=>{"x_grid_lines" => [225,225,225]});
      $my_graph->set("x_ticks"=> $graph_x_labels_style);
      $my_graph->set("skip_x_ticks"=> $graph_x_labels_skip);
      $my_graph->set("min_val"=>$$grid_field_spec{min_val}) if(length($$grid_field_spec{min_val}));
      $my_graph->set("max_val"=>$$grid_field_spec{max_val}) if(length($$grid_field_spec{max_val}));
      $my_graph->set("y_ticks"=>($$grid_field_spec{y_ticks}+1)) if(length($$grid_field_spec{y_ticks}));
      $my_graph->cgi_png(\@graph_data);
   }
   elsif($query_type eq "graph_pie") {
      require GD::Graph::pie;
      $gifx=375; $gify=400;
      $my_graph=GD::Graph::pie->new($gifx,$gify);
      $my_graph->set("3d"=>0, "start_angle"=>90);
      my $graph_suma=0;
      for(my $i=0;$i<$num_rows;$i++) {
         $graph_suma+=$graph_data[1] [$i];
      }
      for(my $i=0;$i<$num_rows;$i++) {
         $graph_data[0] [$i]=$graph_data[0] [$i]." ".sprintf("%3.1f",($graph_data[1] [$i]/$graph_suma)*100)."%";
      }
      $my_graph->set("title"=>$query_name, "gifx"=>$gifx, "gify"=>$gify);
      my $graph_png=$my_graph->plot(\@graph_data)->png;
      print "Expires: ", scalar(localtime), "\n";
      print "Content-Type: image/png\n\n";
      binmode STDOUT;
      print $graph_png;
   }
   elsif($query_type eq "graph_area") {
      require Chart::Mountain;
      $my_graph=Chart::Mountain->new($gifx,$gify);
      $my_graph->set("legend_labels" => \@graph_legend);
      $my_graph->set("x_label"=>$graph_x_label);
      $my_graph->set("title"=>$query_name);
      $my_graph->set("grid_lines"=>"true");
      $my_graph->set("colors"=>{"x_grid_lines" => [225,225,225]});
      $my_graph->set("x_ticks"=> $graph_x_labels_style);
      $my_graph->set("skip_x_ticks"=> $graph_x_labels_skip);
      $my_graph->set("min_val"=>$$grid_field_spec{min_val}) if(length($$grid_field_spec{min_val}));
      $my_graph->set("max_val"=>$$grid_field_spec{max_val}) if(length($$grid_field_spec{max_val}));
      $my_graph->set("y_ticks"=>($$grid_field_spec{y_ticks}+1)) if(length($$grid_field_spec{y_ticks}));
      $my_graph->cgi_png(\@graph_data);
   }
   elsif($query_type eq "graph_lines") {
      require Chart::Lines;
      $my_graph=Chart::Lines->new($gifx,$gify);
      $my_graph->set("legend_labels" => \@graph_legend);
      $my_graph->set("x_label"=>$graph_x_label);
      $my_graph->set("title"=>$query_name);
      $my_graph->set("grid_lines"=>"true");
      $my_graph->set("colors"=>{"x_grid_lines" => [225,225,225]});
      $my_graph->set("brush_size"=> 3);
      $my_graph->set("x_ticks"=> $graph_x_labels_style);
      $my_graph->set("skip_x_ticks"=> $graph_x_labels_skip);
      $my_graph->set("min_val"=>$$grid_field_spec{min_val}) if(length($$grid_field_spec{min_val}));
      $my_graph->set("max_val"=>$$grid_field_spec{max_val}) if(length($$grid_field_spec{max_val}));
      $my_graph->set("y_ticks"=>($$grid_field_spec{y_ticks}+1)) if(length($$grid_field_spec{y_ticks}));
      $my_graph->cgi_png(\@graph_data);
   }
   elsif($query_type eq "graph_linespoints") {
      require Chart::LinesPoints;
      $my_graph=Chart::LinesPoints->new($gifx,$gify);
      $my_graph->set("legend_labels" => \@graph_legend);
      $my_graph->set("x_label"=>$graph_x_label);
      $my_graph->set("title"=>$query_name);
      $my_graph->set("grid_lines"=>"true");
      $my_graph->set("colors"=>{"x_grid_lines" => [225,225,225]});
      $my_graph->set("brush_size"=> 3);
      $my_graph->set("x_ticks"=> $graph_x_labels_style);
      $my_graph->set("skip_x_ticks"=> $graph_x_labels_skip);
      $my_graph->set("min_val"=>$$grid_field_spec{min_val}) if(length($$grid_field_spec{min_val}));
      $my_graph->set("max_val"=>$$grid_field_spec{max_val}) if(length($$grid_field_spec{max_val}));
      $my_graph->set("y_ticks"=>($$grid_field_spec{y_ticks}+1)) if(length($$grid_field_spec{y_ticks}));
      $my_graph->cgi_png(\@graph_data);
   }
}

#= --------------- Zobrazeni ve forme mapy ----------------------------------- =#
## chce to jeste dodelat, aby pri prejizdeni nad statem vyskocila bublina s hodnotou
sub query_print_map {
   my ($pkg_p,$param)=@_;
   require GD;
   my ($cols,$data)=$pkg->query_to_array($param);
   my ($database,$folder,$query_name,$query_group,$query_type,$query_string)=($$param{database},$$param{folder},$$param{query_name},$$param{query_group},$$param{query_type},$$param{query_string});
   my $num_rows=@$data;
   my $map_table=$query_type; $map_table=~s/^map_//;
   my $im = new GD::Image(555,674); ## Rozmery mapy - chce zaznamenat nekde mimo program (muzu mit ruznorode mapy)
   my $blue = $im->colorAllocate(150, 189, 255);
   my $black = $im->colorAllocate(0, 0, 0);
   my $gray = $im->colorAllocate(200, 200, 200);
   # Definovani barev
   my @color;
   my $num_colors=200;
   for(my $i=0; $i<=$num_colors; ++$i) {
      $color[$i]=$im->colorAllocate(250-200/$num_colors*$i,int(250-($i/3)),250-200/$num_colors*$i);
   }
   # Zjisteni maximalni a minimalni hodnoty
   my ($max_val, $min_val);
   my $row=0;
   my %object;
   while($row<$num_rows) {
      $object{$$data[$row][0]{value}}=$$data[$row][1]{value};
      if($$data[$row][1]{value}>$max_val) {
         $max_val=$$data[$row][1]{value};
      }
      if($$data[$row][1]{value}<$min_val) {
         $min_val=$$data[$row][1]{value};
      }
      ++$row;
   }
   my $database_Maps="Maps";
   my $query_string_Maps="
      select
         code, def
      from
         $database_Maps.$map_table
   ";
   my $sth_Maps=$dbh->prepare($query_string_Maps);
   # Vytvoreni mapy
   my $rv_Maps=$sth_Maps->execute;
   while(my $ref_Maps=$sth_Maps->fetchrow_arrayref) {
      my $color=$gray;
      my $color_index=int( ($object{$$ref_Maps[0]}-$min_val) / (($max_val-$min_val)/$num_colors) );
      $color=$color[$color_index] if($object{$$ref_Maps[0]});
      $pkg->draw_country($$ref_Maps[1],$im,$color,$black);
   }
   my $rc_Maps=$sth_Maps->finish;
   # Vytvoreni popisek mapy
   my $rv_Maps=$sth_Maps->execute;
   while(my $ref_Maps=$sth_Maps->fetchrow_arrayref) {
      $pkg->draw_code($$ref_Maps[1],$im,$black,$$ref_Maps[0]);
   }
   my $rc_Maps=$sth_Maps->finish;
   print "Content-Type: image/png\n\n";
   binmode STDOUT;
   print $im->png;
}

# pomocna funkce pro zobrazeni ve forme mapy
sub draw_country {
   my ($pkg_p, $def, $myim, $color, $color_border)=@_;
   foreach my $radek (split(/\n/,$def)) {
      if($radek=~/^.+,.+,/) {
         my $poly=new GD::Polygon;
         my @border=split(/,/,$radek);
         while(@border) {
            my $x=shift @border;
            my $y=shift @border;
            $poly->addPt($x,$y);
         }
         $myim->filledPolygon($poly,$color);
         $myim->polygon($poly,$color_border);
      }
   }
}

# pomocna funkce pro zobrazeni ve forme mapy
sub draw_code {
   my ($pkg_p, $def, $myim, $color, $code)=@_;
   $def=~s/^(.+)$/$1/;
   my ($x,$y)=split(/,/,$def);
   $myim->string(GD::Font->Large,$x-4,$y-5,$code,$color);
}

#= ----------------- Zobrazeni ve forme XML ---------------------------------- =#
sub query_print_xml_table {
   my ($pkg_p,$param)=@_;
   my $query_type=$$param{query_type};
   #- dodatecne upravy param
   if($query_type eq "excel" or $query_type eq "file") {
      $$param{query_type}="txt";
   }
   elsif($query_type eq "xml_raw") {
      $$param{query_type}="xml_table";
   }
   #- spusteni dotazu
   my ($cols,$data,$id,$limit)=$pkg->query_to_array($param);
   #- tisk HTTP hlavicky
   my $xsl_process;
   if($query_type ne "update_add") {
      print "Cache-Control: no-store\n";
   }
   if($query_type eq "excel") {
      print "Content-Type: application/vnd.ms-excel\n\n";
      $xsl_process="server";
   }
   elsif($query_type eq "table" or $query_type=~/^update/ or $query_type eq "file") {
      print "Content-Type: text/html\n\n";
      $xsl_process="server";
   }
   elsif($query_type eq "txt") {
      print "Content-Type: text/plain\n\n";
      $xsl_process="server";
   }
   else {
      print "Content-Type: text/xml\n\n";
      $xsl_process="client";
   }
   my ($mh,$oldfh);
   if($xsl_process eq "server") {
      require MemHandle;
      $mh = new MemHandle;
      $oldfh=select($mh); #zaznamena momentalni nastavni kam jsou standartne smerovany vystupy print (pujde o STDOUT) a nastavy, aby byly smerovany do $mh
   }
   print "<?xml";
         printA("version","1.0");
         printA("encoding",Maccess_locale->charset);
         print "?>";
   print "\n";
   my $name_stylesheet;
   if($query_type ne "xml_raw") {
      $name_stylesheet= "$maccess_lib_path/template_" . $query_type;
      $name_stylesheet.=".xsl";
      print "<?xml-stylesheet";
            printA("type","text/xsl");
            printA("href",$name_stylesheet);
            print "?>";
      print "\n";
   }
   print "<table";
         printA("xmlns:dt","urn:schemas-microsoft-com:datatypes");
         print ">";
   $pkg->query_print_xml_body($param,$cols,$data,$id,$limit);
   print "</table>";
   if($xsl_process eq "server") {
      select($oldfh); # obnoveni, aby prikazy print byly zmerovany tam jak driv
      my $xsl_template;
      open(XSL_TEMPLATE,"$maccess_webpath/$name_stylesheet") || die "template not found ($maccess_webpath/$name_stylesheet)";
      while(my $line=<XSL_TEMPLATE>) {
         $xsl_template.=$line;
      }
      close(XSL_TEMPLATE);
      my $output;
      require XML::Sablotron;
      my $sab=XML::Sablotron->new();
      my $retcode=$sab->RunProcessor( "arg:/template", "arg:/xml_resource", "arg:/result", undef, ["template" => $xsl_template, "xml_resource" => $mh->mem()] );
      $sab->ClearError(); # nevim zda ma nejaky smysl
      $output=$sab->GetResultArg("result");
      $sab->FreeResultArgs(); # nevim zda ma nejaky smysl
      if($query_type eq "txt" or $query_type eq "excel" or $query_type eq "file") { 
         $output=$pkg->recode_charset($output,"UTF-8",Maccess_locale->charset);
      }
      if($query_type eq "file") {
         my @passwd=getpwnam $pkg->get_remote_user;
         my $filename="$passwd[7]/tmp/maccess.txt";
         open(FILE,">$filename") || die "Write error - file $filename.";
         print FILE $output;
         close(FILE);
         printE(translate("Output was saved as file :0.",$filename));
      }
      else {
         print $output;
      }
   }
}

#---- tisk XML tela
sub query_print_xml_body {
   my ($pkg_p,$param,$cols,$data,$id,$limit)=@_;
   my ($database,$folder,$query_name,$query_group,$query_type,$query_string)=($$param{database},$$param{folder},$$param{query_name},$$param{query_group},$$param{query_type},$$param{query_string});
   my $num_rows=@$data;
   my $num_fields=@$cols;
   #- XML cast "query"
   my ($year,$month,$day, $hour,$min,$sec) = Date::Calc::Today_and_Now();
   print "<query>";
   print "<base";
         printA("href","$host_url$maccess_bin_path/");
         print ">";
   print "</base>";
   print "<title>";
   printE("$maccess_ver - $query_name (" . $year . "-" . sprintf("%2.2d",$month) . "-" . sprintf("%2.2d",$day) . " " . sprintf("%2.2d",$hour) . ":" . sprintf("%2.2d",$min) . ")");
   print "</title>";
   print "<header>";
   print "<xhtml>";
   $pkg->print_HTML_head_basic($query_name,1);
   $pkg->print_variables($$param{variables});
   print "</xhtml>";
   print "</header>";
   print "<footer>";
   print "<xhtml>";
   $pkg->print_HTML_foot_basic($database,$folder);
   print "</xhtml>";
   print "</footer>";
   print "<special_settings>";
   print "<control>";
   print "<xhtml>";
   $pkg->print_special_control();
   print "</xhtml>";
   print "</control>";
   print "<change_window>";
   $pkg->print_special_change_window();
   print "</change_window>";
   print "</special_settings>";
   if(defined($limit)) {
      my $limit_records="do.phtml?";
      $limit_records.="id=";
      $limit_records.=encode_uri($id);
      $limit_records.="&limit_records=";
      $limit_records.=encode_uri(($$limit[0]+$$limit[1]) . "," . $$limit[1]);
      print "<limit";
            printA("href",$limit_records);
            print ">";
      printE(translate("next :0 rows",$$limit[1]));
      print "</limit>";
   }
   if($query_type=~/^update/) {
      print "<buttons>";
      print "<xhtml>";
      $pkg->print_update_buttons($query_type);
      print "</xhtml>";
      print "</buttons>";
   }
   print "<id>";
   printE($id);
   print "</id>";
   print "<database>";
   printE($database);
   print "</database>";
   print "<folder>";
   printE($folder);
   print "</folder>";
   print "<query_name>";
   printE($query_name);
   print "</query_name>";
   print "<query_string>";
   printE($query_string);
   print "</query_string>";
   print "<user>";
   printE($pkg->get_remote_user());
   print "</user>";
   print "</query>";
   #- XML cast "cols"
   print "<cols>";
   my $spec_type="xml_table";
   my $number=0;
   for(my $col=0;$col<$num_fields;$col++) {
      if(!$$cols[$col]{xml_group}) {
         $$cols[$col]{number}=$number;
         # POZNAMKA pri tvorbe atributu "tagname", je vse zkraceno na 25 znaku jelikoz u specialniho ukladani nepovoluji delsi polozku - aby spec ukladani fungovalo musi byt prvnich 25 znaku v nazvu sloupce jedinecnych
         my $grid_field_spec=$pkg->query_file_spec_to_hash($database,$folder,$query_name,$spec_type,$$cols[$col]{tagname},$$cols[$col]{number});
         if(!defined($$cols[$col]{chosen})) {
            if(defined($$grid_field_spec{chosen})) {
               $$cols[$col]{chosen}= $$grid_field_spec{chosen};
            }
            else {
               $$cols[$col]{chosen}= "0";
            }
         }
         if(defined($$grid_field_spec{show})) {
            $$cols[$col]{show}= $$grid_field_spec{show};
         }
         else {
            $$cols[$col]{show}="1";
         }
         $$cols[$col]{format}=$$grid_field_spec{format};
         if($$cols[$col]{type} eq "number" and !defined($$grid_field_spec{format})) {
            $$cols[$col]{summary}="sum";
         }
         else {
            $$cols[$col]{summary}=$$grid_field_spec{summary};
         }
         print "<col";
               printA("name",$$cols[$col]{tagname});
               printA("number",$$cols[$col]{number});
               printA("chosen",$$cols[$col]{chosen});
               printA("show",$$cols[$col]{show});
               printA("type",$$cols[$col]{type});
               printA("sqltype",$$cols[$col]{sqltype}) if($$cols[$col]{sqltype});
               printA("format",$$cols[$col]{format});
               printA("summary",$$cols[$col]{summary});
               printA("sqlname",$$cols[$col]{sqlname}) if($$cols[$col]{sqlname});
               printA("sqljoin",$$cols[$col]{sqljoin}) if($$cols[$col]{sqljoin});
               printA("prikey",$$cols[$col]{prikey}) if($$cols[$col]{prikey});
               printA("update",$$cols[$col]{update}) if($$cols[$col]{update});
               printA("length",$$cols[$col]{length}) if($$cols[$col]{length});
               print ">";
         if($$cols[$col]{name}!~/^<xhtml>/) {
            printE($$cols[$col]{name});
         }
         else {
            print $$cols[$col]{name};
         }
         print "</col>";
         ++$number;
      }
   }
   print "</cols>";
   #- XML cast "rows"
   print "<rows>";
   my $number=0;
   while($number<$num_rows) {
      $number=$pkg->print_rows($data,$cols,$number,0);
   }
   print "</rows>";
}

#- tisk radku v XML vystupu
sub print_rows {
   my ($pkg_p,$data,$cols,$number,$group_depth)=@_;
   my $num_rows=@$data;
   my ($xml_group_values,$col_group)=$pkg->xml_group_values($data,$cols,$number,$group_depth);
   my $xml_group_values_row=$xml_group_values;
   my ($xml_group_values_row_all)=$pkg->xml_group_values($data,$cols,$number);
   # jsem na nejnizsi urovni
   if($group_depth==($#{$xml_group_values_row_all}+1)) {
      while($pkg->is_array_equivalent($xml_group_values,$xml_group_values_row) and $number<$num_rows) {
         print "<row";
               printA("number",$number);
               printA("chosen","0");
               print ">";
         my $num_fields=@$cols;
         for(my $col=0;$col<$num_fields;++$col) {
            if(!$$cols[$col]{xml_group}) {
               # tisk znacek s hodnotou
               $pkg->printTag("col",$$data[$number][$col]{value},$$data[$number][$col]{style},$$data[$number][$col]{href},$$cols[$col]{type});
            }
         }
         print "</row>";
         ++$number;
         ($xml_group_values_row)=$pkg->xml_group_values($data,$cols,$number,$group_depth);
      }
   }
   # nejsem na nejnizsi urovni
   else {
      print "<rows>";
      $pkg->printTag("rows_heading",$$data[$number][$col_group]{value},$$data[$number][$col_group]{style},$$data[$number][$col_group]{href},$$cols[$col_group]{type});
      while($pkg->is_array_equivalent($xml_group_values,$xml_group_values_row)) {
         $number=$pkg->print_rows($data,$cols,$number,$group_depth+1);
         ($xml_group_values_row)=$pkg->xml_group_values($data,$cols,$number,$group_depth);
      }
      print "</rows>";
   }
   return $number;
}

#- funkce vraci seznam hodnot sloupcu, ktere jsou xml_group
sub xml_group_values {
   my ($pkg_p,$data,$cols,$number,$group_depth_max)=@_;
   my $group_depth=0;
   my @xml_group_values;
   my $num_fields=@$cols;
   my $col;
   for($col=0;$col<$num_fields;++$col) {
      if($$cols[$col]{xml_group}) {
         push(@xml_group_values,$$data[$number][$col]{value});
         last if(defined($group_depth_max) and $group_depth==$group_depth_max);
         ++$group_depth;
      }
   }
   return (\@xml_group_values,$col);
}

#- pomocna funkce zjistujici, zda jsou dve pole ekvivalentni
sub is_array_equivalent {
   my ($pkg_p,$a1,$a2)=@_;
   return 0 if($#{$a1}!=$#{$a2});   # pole maji ruznou delku
   for(my $i=0;$i<=$#{$a1};++$i) {  # poravnavani prvku po prvku
      return 0 if($$a1[$i] ne $$a2[$i]);
   }
   return 1;
}

#- tisk xml znacek a hodnot
sub printTag {
   my ($pkg_p,$tagname,$value,$style,$href,$type)=@_;   # !!! pozor mam obavu ze pokud bude $style undef tak se bude sypat konverze xml+xsl na serveru
   # pozor konverze na xml+xsl se na servru hroutila kdyz zde nebylo my $style=""; ale jen my $style;
   if($type eq "number") {
      if(!defined($value) or $value eq '') {
         $type="";
      }
   }
   elsif($type eq "date") {
      my ($year,$month,$day)=split(/-/,$value);
      if(!Date::Calc::check_date($year,$month,$day)) {
         $type="";
         if(defined($value) and $value ne "") {
            $style="text-decoration: line-through; $style";
         }
      }
   }
   elsif($type eq "time") {
      if(!($value=~/^(\d\d):[0-5]\d:[0-5]\d$/ and $1<=24)) {
         $type="";
         if(defined($value) and $value ne "") {
            $style="text-decoration: line-through; $style";
         }
      }
   }
   elsif($type eq "dateTime") {
      if($value=~/^(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})$/) {   # jde o timestamp ve tvaru YYYYMMDDHHMMSS
         $value="$1-$2-$3 $4:$5:$6";
      }
      my ($date,$time)=split(/ /,$value);
      my ($year,$month,$day)=split(/-/,$date);
      if(!Date::Calc::check_date($year,$month,$day) or !($time=~/^(\d\d):[0-5]\d:[0-5]\d$/ and $1<=24)) {
         $type="";
         if(defined($value) and $value ne "") {
               $style="text-decoration: line-through; $style";
         }
      }
      else {
         $value="${date}T${time}";
      }
   }
   print "<$tagname";
   if($type) {
      printA("dt:dt",$type);
   }
   if($style) {
      printA("style",$style);
   }
   if($href) {
      printA("href",$href);
   }
   print ">";
   if($value!~/^<xhtml>/) {
      printE($value);
   }
   else {
      print $value;
   }
   print "</$tagname>";
}







#-============= UPDATE funkce ================================================-#
#--------------- Vraci polozky tabulek ziskane z formulare form_update --------#
sub get_col_update {
   my (@tables_fullname,%col_val,%pri_val);
   # vracene hodnoty - %col_val
   foreach my $key ($query->param) {
      if($key=~/^([^\.]+)\.([^\.]+)\.([^\.]+)$/) {
         my $database=$1;
         my $table=$2;
         my $col=$3;
         $col_val{"$database.$table"}{$col}=$pkg->recode_charset($query->param($key),"UTF-8",Maccess_locale->charset);
         #- z formulare muze mit vstup zadany rucne ruznou datovou podobu - proto provadim jeste nejake konverze
         $col_val{"$database.$table"}{$col}=$pkg->correct_input($pkg->field_sqltype_by_col_fullname("$database.$table.$col"),$col_val{"$database.$table"}{$col});
         if(!grep(/^\Q$database.$table\E$/,@tables_fullname)) {
            push(@tables_fullname,"$database.$table");
         }
      }
   }
   foreach my $key ($query->param) {
      if($key=~/^JOIN\.([^\.]+)\.([^\.]+)\.([^\.]+)$/) {
         my $database=$1;
         my $table=$2;
         my $col=$3;
         my $coljoin_fullname=$pkg->recode_charset($query->param($key),"UTF-8",Maccess_locale->charset);
         if($coljoin_fullname=~/^([^\.]+)\.([^\.]+)\.([^\.]+)$/) {
            my $databasejoin=$1;
            my $tablejoin=$2;
            my $coljoin=$3;
            $col_val{"$database.$table"}{$col}=$col_val{"$databasejoin.$tablejoin"}{$coljoin};
            if(!grep(/^\Q$database.$table\E$/,@tables_fullname)) {
               push(@tables_fullname,"$database.$table");
            }
         }
      }
   }
   # vracene hodnoty primarnich klicu - %pri_val
   my @pris;
   foreach my $key ($query->param) {
      if($key=~/^PRI\.([^\.]+)\.([^\.]+)\.([^\.]+)$/) {
         my $database=$1;
         my $table=$2;
         my $col=$3;
         if(!grep(/^\Q$database.$table.$col\E$/,@pris)) {
            push(@pris,"$database.$table.$col");
         }
         $pri_val{"$database.$table"}{$col}=$pkg->recode_charset($query->param($key),"UTF-8",Maccess_locale->charset);
         if(!grep(/^\Q$database.$table\E$/,@tables_fullname)) {
            push(@tables_fullname,"$database.$table");
         }
      }
   }
   return (\@tables_fullname,\%col_val,\%pri_val);
}

#- z formulare muze mit vstup zadany rucne ruznou datovou podobu - proto provadim jeste nejake konverze
sub correct_input {
   my ($pkg_p,$data_type_string,$col_val)=@_;
   if($data_type_string eq "date") {
      $col_val=Maccess_query_string->correct_date($col_val);
   }
   elsif($data_type_string eq "datetime") {
      if($col_val=~/^(.+)[ T](.+)$/i) {
         my $date=$1;
         my $time=$2;
         $date=Maccess_query_string->correct_date($date);
         $col_val="$date $time";
      }
   }
   elsif($data_type_string eq "timestamp") {
      if($col_val=~/^(.+)[ T](.+)$/i) {
         my $date=$1;
         my $time=$2;
         $date=Maccess_query_string->correct_date($date);
         $col_val="$date $time";
      }
      $col_val=~s/[^\d]//gi;
      $col_val= $col_val . ("0" x (14-length($col_val)));
   }
   return $col_val;
}

#--------------- Funkce zjistuje, ktere tabulky mohou byt aktualizovany (znam u nich vsecky primarni klice) a to ze seznamu primarnich klicu
sub tables_maybeupdate {
   my ($pkg_p,@pris)=@_;
   # zjisteni vsech tabulek z kterych jsou primarni klice
   my @tables_fullname_pom;
   foreach my $pri (@pris) {
      $pri=~/^([^\.]+)\.([^\.]+)\.([^\.]+)$/;
      my $table_fullname="$1.$2";
      if(!grep(/^\Q$table_fullname\E$/,@tables_fullname_pom)) {
         push(@tables_fullname_pom,$table_fullname);
      }
   }
   # zjisteni tabulek, ktere je mozno aktualizovat - znam jejich primarni klice
   my @tables_fullname;
   foreach my $table_fullname (@tables_fullname_pom) {
      my $push_table=1;
      foreach my $pri (Maccess_query_string->primary_keys($table_fullname)) {
         if(!grep(/^\Q$pri\E$/,@pris)) {
            $push_table=0;
            last;
         }
      }
      if($push_table) {
         push(@tables_fullname,$table_fullname);
      }
   }
   return @tables_fullname;
}

#--------------- Uprava zaznamu - Uprav -----------------#
sub update_rec {
   my ($user,$pass)=$pkg->user_sql($pkg->get_remote_user);
   my $dbh_user=DBI->connect("DBI:$driver:$database_test:$hostname",$user,$pass);
   my %status;
   my ($tables_fullname,$col_val,$pri_val)=$pkg->get_col_update;
   # vyhledej zaznam u kazde tabulky a zjisit zda doslo ke zmenam pokud ano tak aktualizuj, ale jen ty sloupce co byly zmeneny (uzivatel muze mit pravo jen na zmenu nekterych sloupcu)
   foreach my $table_fullname (@$tables_fullname) {
      my @cols_update; # pole kde budou jmena sloupcu urcene k aktualizaci
      my @cols=keys %{$$col_val{$table_fullname}};
      my @pris=keys %{$$pri_val{$table_fullname}};
      my %query_hash;
      $query_hash{COLS}=join(",",@cols);
      $query_hash{FROM}=$table_fullname;
      $query_hash{WHERE}= join("=? and ",@pris) . "=?";
      $query_hash{LIMIT}="1";
      my $query_string=Maccess_query_string->query_hash_to_query_string(\%query_hash);
      my $sth=$dbh_user->prepare($query_string);
      my $placeholder=1;
      foreach my $pri (@pris) {
         $sth->bind_param($placeholder, $$pri_val{$table_fullname}{$pri});
         ++$placeholder;
      }
      my $rv=$sth->execute;
      my $ref=$sth->fetchrow_arrayref;
      my $col_number=0;
      foreach my $col (@cols) {
         if($$ref[$col_number] ne $$col_val{$table_fullname}{$col}) {
            push(@cols_update,$col);
         }
         ++$col_number;
      }
      my $rc=$sth->finish;
      #- aktualizace
      if(@cols_update) {
         my $query_string="UPDATE $table_fullname SET ";
         $query_string.= join("=?,",@cols_update) . "=?";
         $query_string.= " WHERE ";
         $query_string.= join("=? and ",@pris) . "=?";
         my $sth=$dbh_user->prepare($query_string);
         my $placeholder=1;
         foreach my $col (@cols_update) {
            $sth->bind_param($placeholder, $$col_val{$table_fullname}{$col});
            ++$placeholder;
         }
         foreach my $pri (@pris) {
            $sth->bind_param($placeholder, $$pri_val{$table_fullname}{$pri});
            ++$placeholder;
         }
         eval {
            local $SIG{__WARN__}=sub { $status{$table_fullname}=$_[0]; };
            my $rv=$sth->execute;
            if(defined($rv)) {
               $status{$table_fullname}="ok";
            }
         };
         my $rc=$sth->finish;
      }
   }
   $dbh_user->disconnect;
   return \%status;
}

#--------------- Uprava zaznamu - Pridej -----------------#
sub add_rec {
   my ($user,$pass)=$pkg->user_sql($pkg->get_remote_user);
   my $dbh_user=DBI->connect("DBI:$driver:$database_test:$hostname",$user,$pass);
   my %status;
   my ($tables_fullname,$col_val,$pri_val)=$pkg->get_col_update;
   foreach my $table_fullname (@$tables_fullname) {
      my @cols_update=keys %{$$col_val{$table_fullname}};
      my $query_string="INSERT $table_fullname SET ";
      $query_string.= join("=?,",@cols_update) . "=?";
      my $sth=$dbh_user->prepare($query_string);
      my $placeholder=1;
      foreach my $col (@cols_update) {
         $sth->bind_param($placeholder, $$col_val{$table_fullname}{$col});
         ++$placeholder;
      }
      eval {
         local $SIG{__WARN__}=sub { $status{$table_fullname}=$_[0]; };
         my $rv=$sth->execute;
         if(defined($rv)) {
            $status{$table_fullname}="ok";
         }
      };
      my $rc=$sth->finish;
   }
   $dbh_user->disconnect;
   return \%status;
}

#--------------- Uprava zaznamu - Smaz -----------------#
sub delete_rec {
   my ($user,$pass)=$pkg->user_sql($pkg->get_remote_user);
   my $dbh_user=DBI->connect("DBI:$driver:$database_test:$hostname",$user,$pass);
   my %status;
   my ($tables_fullname,$col_val,$pri_val)=$pkg->get_col_update;
   foreach my $table_fullname (@$tables_fullname) {
      my @pris=keys %{$$pri_val{$table_fullname}};
      my $query_string="DELETE FROM $table_fullname";
      $query_string.= " WHERE ";
      $query_string.= join("=? and ",@pris) . "=?";
      my $sth=$dbh_user->prepare($query_string);
      my $placeholder=1;
      foreach my $pri (@pris) {
         $sth->bind_param($placeholder, $$pri_val{$table_fullname}{$pri});
         ++$placeholder;
      }
      eval {
         local $SIG{__WARN__}=sub { $status{$table_fullname}=$_[0]; };
         my $rv=$sth->execute;
         if(defined($rv)) {
            $status{$table_fullname}="ok";
         }
      };
      my $rc=$sth->finish;
   }
   $dbh_user->disconnect;
   return \%status;
}

#--------------- Uprava zaznamu - Zobrazeni vysledku -----------------#
sub print_update_status {
   my ($pkg_p,$status,$type,$param)=@_;
   my ($database,$folder,$query_name)=($$param{database},$$param{folder},$$param{query_name});
   my $bad=grep(!/^\Qok\E$/,values(%$status));
   my @types=(translate("Update"),translate("Add"),translate("Delete"));
   if($$param{query_type} eq "update" or $bad) {
      print "Content-Type: text/html\n\n";
      print "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"DTD/xhtml1-transitional.dtd\">\n";
      $pkg->print_HTML_head($query_name,"","",1);
      print "<ul>";
      foreach my $table_fullname (keys %$status) {
         print "<li>";
         printE("$types[$type] $table_fullname - ");
         if($$status{$table_fullname} eq "ok") {
            print "<span";
                  printA("style","color: green");
                  print ">";
            printE(translate("ok"));
            print "</span>";
         }
         else {
            print "<span";
                  printA("style","color: red");
                  print ">";
            printE(translate("error"));
            print "</span>";
            print "<br/>";
            print "<b>";
            printE($$status{$table_fullname});
            print "</b>";
         }
         print "</li>";
      }
      print "</ul>";
      if(!$bad) {
         print "<script";
               printA("type","text/javascript");
               print ">";
         print "history.go(-2);";
         print "</script>";
      }
      $pkg->print_HTML_foot($database,$folder);
   }
   return $bad;
}

#--------------- Provedeni akcniho query_string ---------#
sub do_action_query_string {
   my ($pkg_p,$database,$query_string)=@_;
   my ($user,$pass)=$pkg->user_sql($pkg->get_remote_user);
   my $dbh_user=DBI->connect("DBI:$driver:$database:$hostname",$user,$pass) || die "DBI connect error";
   my $sth=$dbh_user->prepare($query_string);
   my $rv=$sth->execute;
   my $rc=$sth->finish;
   $dbh_user->disconnect;
}




#-============= DEKLARACE RUZNYCH FUNKCI ======================================-#
#--------------- Promena ve formulari generujici padaci menu z sql dotazu ------#
sub print_select_menu_q {
   my ($pkg_p,$promena,$query_string,$database)=@_;
   my ($user,$pass)=$pkg->user_sql($pkg->get_remote_user);
   my $dbh_user=DBI->connect("DBI:$driver:$database:$hostname",$user,$pass);
   my $query_hash=Maccess_query_string->query_string_to_query_hash($query_string);
   if(!length($$query_hash{FROM})) {
      my $sth=$dbh_user->prepare($query_string);
      my $rv=$sth->execute;
      my $ref=$sth->fetchrow_arrayref;
      my $hodnota=$$ref[0];
      my $rc=$sth->finish;
      print "<input";
            printA("name","VAR_$promena");
            printA("type","text");
            printA("value",$hodnota);
            print "/>";
   }
   else {
      if(!length($$query_hash{LIMIT})) {
         $$query_hash{LIMIT}=500;
      }
      $query_string=Maccess_query_string->query_hash_to_query_string($query_hash);
      print "<select";
            printA("name","VAR_$promena");
            print ">";
      my $sth=$dbh_user->prepare($query_string);
      my $rv=$sth->execute;
      while(my $ref=$sth->fetchrow_arrayref) {
         print "<option";
               printA("value",$$ref[0]);
               print ">";
         printE($$ref[1]);
         print "</option>";
      }
      my $rc=$sth->finish;
      print "</select>\n";
   }
   $dbh_user->disconnect;
}

#--------------- Promena ve formulari generujici padaci menu -------------------#
sub print_select_menu {
   my ($pkg_p,$promena,$values)=@_;
   my @values=split(/\|/,$values);
   print "<select";
         printA("name","VAR_$promena");
         print ">";
   for(my $i=0; $i<=$#values; $i+=2) {
      print "<option";
            printA("value",$values[$i]);
            print ">";
      printE($values[$i+1]);
      print "</option>";
   }
   print "</select>";
}

# obecne pouziti 2 funkci nize:
# query_mrizka -> encode_maccess;  sloupce vracene MySQL -> decode_maccess;  dekodovane sloupce -> encode_tagname a zapis do XML souboru (drive jako jmena znacek pozdeji jako obsah atributu name ve znacce <col> a jen v sekci <cols>)
#--------------- Funkce kodujici znaky nazvu sloupcu vracenych MySQL do "maccessovskeho" opisu pouzitelneho pro MySQL a take XML znacky
sub encode_maccess {
   my ($pkg_pom,$str)=@_;
   $str=~s/^([0-9])/"_x".unpack("H2",$1)."_"/e;  # v XML nemuze zacinat znacka cislici - proto pokud retezec zacina cislici je nutne encodovat i ji (muze klidne zacinat znakem _)
   $str=~s/([\x20-\x2F\x3A-\x40\x5B-\x5E\x60\x7B-\x7E])/"_x".unpack("H2",$1)."_"/ge;  # ASCII tabulka: http://members.tripod.com/~plangford/index.html
   return $str;
}
#--------------- Funkce dekodujici znaky sloupcu ze znacek XML pro zjisteni skutecneho nazvu sloupce
sub decode_maccess {
   my ($pkg_pom,$str)=@_;
   $str=~s/_x([\da-f]{2,3})_/pack("H2",$1)/ge;
   return $str;
}
#--------------- Funkce pro kodovani znacek
sub encode_tagname {
   my ($pkg_pom,$str)=@_;
   # $str=substr($pkg->encode_maccess($str),0,25); # pouzito drive opravdu pro znacky
   $str=~s/\|//gs; # pripadny znak | v tagname rusim, jelikoz ho pouzivam jako oddelovac polozek pri ukladani spec nastaveni v template_xml_table.js
   $str=~s/^\<xhtml\>(.*)\<\/xhtml\>$/$1/gs; # pokud nazev sloupce zacina znackami <xhtml> tak je radeji odstarnim - jednak se zbavim zbytecneho udaje a jednak pak budu moci klast dotazy na tabulku Query_spec_attribute (coz pokud by doslo k urezani tak by hodnota byla treba <xhtml><b>sloupec</b ....)
   $str=substr($str,0,25); # presel jsem na tvar <col name="tagname" ...> - tedy jiz nejde o znacku, ale atribut a jen v sekci <cols>
   return $str;
}
#------- Funkce zakoduje uri zpusobem napred znak % a pak znaky , | - vhodne pro listy, kde jako oddelovace mezi klicem a hodnou pouzivas "," a mezi pary "|" (klice i hodnoty musis zakodovat a pozdeji zvlast dekodovat)
sub encode_list {
   my ($pkg_pom,$str)=@_;
   $str=~s/([\%])/"%".unpack("H2",$1)/ge;
   $str=~s/([\,\|])/"%".unpack("H2",$1)/ge;
   return $str;
}
#------- Funkce dekoduje z uri opisu znaky , | %
sub decode_list {
   my ($pkg_pom,$str)=@_;
   $str=~s/\%2C/\,/gi;
   $str=~s/\%7C/\|/gi;
   $str=~s/\%25/\%/gi;
   return $str;
}

#------- Funkce zajistujici prekodovani znaku mezi znakovymi sadamy
sub recode_charset {
   my ($pkg_p,$str_s,$charset_s,$charset_t)=@_;
   my $str_t;
   # jmena znakovych sad pouzivanych v knihovne Unicode::Map8 jsou jina a musi se pro ni "prelozit"
   my %charset_pkgUnicode=Maccess_locale->charset_pkgUnicode;
   $charset_s=$charset_pkgUnicode{$charset_s};
   $charset_t=$charset_pkgUnicode{$charset_t};
   if($charset_t eq "UTF-8") {
      my $map_s=Unicode::Map8->new($charset_s) || die;
      $str_t=$map_s->to16($str_s); # prevod do UTF-16
      # neni testovano
      $str_t=Unicode::String::utf16($str_t); # "oznameni", ze retezec je v UTF-16
      $str_t=$str_t->utf8; # prevod do UTF-8
   }
   elsif($charset_s eq "UTF-8") {
      my $map_t=Unicode::Map8->new($charset_t) || die;
      $str_s=Unicode::String::utf8($str_s); # "oznameni", ze retezec je v UTF-8
      $str_s=$str_s->utf16; # prevod do UTF-16
      $str_t=$map_t->to8($str_s); # konverze z UTF-16 do prislusne 8bitove sady
   }
   else {
      my $map_s=Unicode::Map8->new($charset_s) || die;
      my $map_t=Unicode::Map8->new($charset_t) || die;
      $str_t=$map_s->recode8($map_t,$str_s);
   }
   return $str_t;
}

#--------------- Funkce vraci seznam klicu a hodnot, ktere se podili na grupovani a je potreba je pouzit k odgrupovani
sub ungroup_by {
   my ($pkg_p,$cols_group,$names_hash)=@_;
   my $ungroup_by;
   foreach my $col_group (@$cols_group) {
      $ungroup_by.= $pkg->encode_list($col_group) . "," . $pkg->encode_list($$names_hash{$col_group}) . "|";
   }
   chop($ungroup_by);
   return $ungroup_by;
}

#--------------- Tisk chybove hlasky pri selhani spusteni dotazu v Maccessu
sub print_error_syntax {
   my ($pkg_p,$param,$error)=@_;
   print "Content-Type: text/html\n\n";
   print "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"DTD/xhtml1-transitional.dtd\">\n";
   $pkg->print_HTML_head(
      translate("Syntax error in query :0.",$$param{query_name}),
      "",
      "",
      1
   );
   print "<p>";
   print "<b>";
   printE(translate("SQL command:"));
   print "</b>";
   print "</p>";
   print "<p>";
   printE($$param{query_string});
   print "</p>";
   print "<p>";
   print "<b>";
   printE(translate("Error returned by SQL server:"));
   print "</b>";
   print "</p>";
   print "<p>";
   printE($error);
   print "</p>";
   $pkg->print_HTML_foot(
      $$param{database},
      $$param{folder}
   );
}

#--------------- Tisk hlavicky HTML dokumentu
sub print_HTML_head {
   my ($pkg_p,$query_name,$extra_head,$extra_body,$maccess_ver_notshow)=@_;
   $query_name=~s/ - $//;
   print "<html>";
   print "<head>";
   print "<meta";
      printA("http-equiv","Content-Type");
      printA("content","text/html; charset=" . Maccess_locale->charset);
      print "/>";
   print "<base";
      printA("href",encode_uri("$host_url$maccess_bin_path/"));
      print ">";
   print "</base>";
   print "<title>";
   printE("$maccess_ver - $query_name");
   print "</title>";
   print "<link";
      printA("rel","stylesheet");
      printA("type","text/css");
      printA("href",encode_uri("$maccess_lib_path/maccess.css"));
      print ">";
   print "</link>";
   print "<link";
      printA("rel","stylesheet");
      printA("type","text/css");
      printA("media","print");
      printA("href",encode_uri("$maccess_lib_path/maccess_print.css"));
      print ">";
   print "</link>";
   print "$extra_head";
   print "</head>";
   print "<body $extra_body>";
   $pkg->print_HTML_head_basic($query_name,$maccess_ver_notshow);
   return 1;
}
sub print_HTML_head_basic {
   my ($pkg_p,$query_name,$maccess_ver_notshow)=@_;
   print "<div>";
   print "<a";
         printA("href",encode_uri("http://www.meopta.com/products/software/maccess/"));
         print ">";
   print "<img";
         printA("src",encode_uri("$maccess_lib_path/logo.gif"));
         printA("alt","logo");
         printA("style","border: 0px; float: right;");
         print " />";
   print "</a>";
   print "</div>";
   if($maccess_ver_notshow) {
      print "<h1>";
      printE($query_name);
      print "</h1>";
   }
   elsif($query_name) {
      print "<h1>";
      printE("$maccess_ver - $query_name");
      print "</h1>";
   }
   else {
      print "<h1>";
      printE("$maccess_ver");
      print "</h1>";
   }
   return 1;
}

#--------------- Tisk paty HTML dokumentu
sub print_HTML_foot {
   my ($pkg_p,$database,$folder)=@_;
   $pkg->print_HTML_foot_basic($database,$folder);
   print "</body>";
   print "</html>";
   return 1;
}
sub print_HTML_foot_basic {
   my ($pkg_p,$database,$folder)=@_;
   print "<div";
         printA("class","footer");
         print ">";
   print "<hr";
         printA("class","footer");
         print " />";
   print "<a";
         printA("class","footer");
         printA("target","_top");
         printA("href","/");
         print ">";
   printE(translate("Home"));
   print "</a>";
   if($database ne "0") { # $database eq "0" specialni pripad - uvodni stranka Maccessu
      print " &#124; ";
      print "<a";
            printA("class","footer");
            printA("target","_top");
            printA("href","./");
            print ">";
      printE("Maccess");
      print "</a>";
   }
   if($database) {
      print " &#124; ";
      print "<a";
            printA("class","footer");
            printA("target","_top");
            printA("href", "database.phtml?database=" . encode_uri($database) );
            print ">";
      printE($database);
      print "</a>";
   }
   if($folder) {
      print " &#124; ";
      print "<a";
            printA("class","footer");
            printA("target","_top");
            printA("href", "database.phtml?database=" . encode_uri($database) . "&folder=" . encode_uri($folder) );
            print ">";
      printE("$database - $folder");
      print "</a>";
   }
   print "</div>";
   return 1;
}

#--------------- Tisk input polozek jako je database, folder, query_name a query_type
sub print_basic_input_hidden {
   my ($pkg_p,$database,$folder,$query_name,$query_type)=@_;
   if(defined($database)) {
      print "<input";
            printA("type","hidden");
            printA("name","database");
            printA("value",$database);
            print "/>";
   }
   if(defined($folder)) {
      print "<input";
            printA("type","hidden");
            printA("name","folder");
            printA("value",$folder);
            print "/>";
   }
   if(defined($query_name)) {
      print "<input";
            printA("type","hidden");
            printA("name","query_name");
            printA("value",$query_name);
            print "/>";
   }
   if(defined($query_type)) {
      print "<input";
            printA("type","hidden");
            printA("name","query_type");
            printA("value",$query_type);
            print "/>";
   }
}

#--------------- Tisk cudliku u update dotazu
sub print_update_buttons {
   my ($pkg_p,$query_type)=@_;
   print "<p>";
   if($query_type eq "update") {
      print "<input";
            printA("name","submit_update");
            printA("type","submit");
            printA("value",translate("Update"));
            printA("style","background-color: #33AA33");
            print "/>";
      print "&#160;";
      print "<input";
            printA("name","submit_add");
            printA("type","submit");
            printA("value",translate("Add"));
            print "/>";
      print "&#160;";
      print "<input";
            printA("name","submit_delete");
            printA("type","submit");
            printA("value",translate("Delete"));
            print "/>";
   }
   else {
      print "<input";
            printA("name","submit_add");
            printA("type","submit");
            printA("value",translate("Add"));
            printA("style","background-color: #33AA33");
            print "/>";
   }   
   print "</p>";
}

## presun tyhle funkce jinam - ZACATEK
## no casem bude MOZNA logictejsi to presunout do sablony - ovsem bude to chtit nejak vyresit ten jazyk
#--------------- Tisk cudliku u update dotazu - neni to primo v sablone, jelikoz zde mohu volit jazyk
sub print_special_control {
   # pomocne prvky
   print "<div";
         printA("id","window_format");
         printA("style","display:none; position: absolute; z-index: 1; width: 150px; background-color: white; border: 1px solid black; padding: 8px;");
         print ">";
   print "</div>";
   print "<div";
         printA("style","display:none");
         print ">";
   print "<iframe";
         printA("name","window_save");
         printA("src","../lib/blank.html");
         print ">";
   print "</iframe>";
   print "<form";
         printA("id","form_save");
         printA("target","window_save");
         printA("method","post");
         printA("action","$maccess_bin_path/spec_save_xml_table.phtml");
         print ">";
   print "</form>";
   print "</div>";
   # ovkladaci prvky
   print "<div";
         printA("class","button");
         print ">";
      printE("[ ");
      printE(translate("Filtr:"));
      printE(" ");
      print "<span";
            printA("class","button");
            printA("style","background-color:#FFFFAA");
            printA("onclick","filtr(1)");
            printA("title",translate("if you click on the row, it will turn yellow"));
            print ">";
      printE(translate("only"));
      print "</span>";
      print "&#160;";
      print "<span";
            printA("class","button");
            printA("style","background-color:#FFAAAA");
            printA("onclick","filtr(2)");
            printA("title",translate("if you press Alt and click on the row, it will turn red"));
            print ">";
      printE(translate("only"));
      print "</span>";
      print "&#160;";
      print "<span";
            printA("class","button");
            printA("style","background-color:#DFDFDF");
            printA("onclick","filtr(0)");
            printA("title",translate("you unmark the marked row by clicking on it"));
            print ">";
      printE(translate("only"));
      print "</span>";
      print "&#160;";
      print "<span";
            printA("class","button");
            printA("onclick","filtr()");
            print ">";
      printE(translate("unfilter"));
      print "</span>";
      printE(" ]");
      printE(" [ ");
      print "<span";
            printA("class","button");
            printA("style","background-color:#DFDFDF");
            printA("onclick","unselect_fun(0)");
            print ">";
      printE(translate("unmark all"));
      print "</span>";
      printE(" ]");
      printE(" [ ");
      print "<span";
            printA("class","button");
            printA("onclick","show_all_cols()");
            printA("title",translate("all hidden columns will be shown"));
            print ">";
      printE(translate("show all columns"));
      print "</span>";
      printE(" ]");
      printE(" [ ");
      print "<span";
            printA("class","button");
            printA("onclick","save_fun()");
            printA("title",translate("saving settings of columns - information about format, information about the type of the shown summary and information about hidden columns"));
            print ">";
      printE(translate("save spec. settings"));
      print "</span>";
      printE(" ]");
   print "</div>";
}

#--------------- Tisk nekterych prvku zobrazujicich se v okne specialniho nastaveni
sub print_special_change_window {
   foreach my $type ("","number","date","dateTime","time") {
      print "<window";
            printA("type",$type);
            print ">";
      print "<form";
            printA("id","window_form");
            printA("onsubmit","spec_change()");
            print ">";
      print "<div>";
      print "<input";
            printA("name","col_number");
            printA("type","hidden");
            printA("value","");
            print "/>";
      if($type ne "") {
         print "<p>";
         printE(translate("Format:"));
         print "<br/>";
         print "<select";
               printA("name","col_format_select");
               printA("style","width: 100%");
               printA("onchange","col_format.value=col_format_select.value");
               print ">";
      }
      #- ukazka formatu zacatek
      if($type eq "number") { #- ukazka formatovani number
         print "<option>";
         printE(translate("examples"));
         print "</option>";
         print "<option";
               printA("value","#,##0.00");
               print ">";
         printE(translate("1,214.20"));
         print "</option>";
         print "<option";
               printA("value","#,##0");
               print ">";
         printE(translate("1,214"));
         print "</option>";
         print "<option";
               printA("value",translate("\$ #,##0.00"));
               print ">";
         printE(translate("\$ 1,214.20"));
         print "</option>";
         print "<option";
               printA("value",translate("+#,##0.00 pcs;-#,##0.00 pcs"));
               print ">";
         printE(translate("+1,214.20 pcs"));
         print "</option>";
         print "<option";
               printA("value","0,");
               print ">";
         printE("1");
         print "</option>";
         print "<option";
               printA("value","#,##0 \\%");
               print ">";
         printE("22 %");
         print "</option>";
      }
      elsif($type eq "date") { #- ukazka formatovani date
         print "<option>";
         printE(translate("examples"));
         print "</option>";
         print "<option";
               printA("value","dd.MM.yyyy");
               print ">";
         printE("01.01.1999");
         print "</option>";
         print "<option";
               printA("value","d.M.yyyy");
               print ">";
         printE("1.1.1999");
         print "</option>";
         print "<option";
               printA("value","d.M.yy");
               print ">";
         printE("1.1.99");
         print "</option>";
         print "<option";
               printA("value","yyyy-MM");
               print ">";
         printE("1999-01");
         print "</option>";
         print "<option";
               printA("value",translate("MM/dd/yyyy (ddd)"));
               print ">";
         printE(translate("01/01/1999 (Fri)"));
         print "</option>";
         print "<option";
               printA("value",translate("MMMM d yyyy"));
               print ">";
         printE(translate("January 1 1999"));
         print "</option>";
      }
      elsif($type eq "dateTime") { #- ukazka formatovani dateTime
         print "<option>";
         printE(translate("examples"));
         print "</option>";
      }
      elsif($type eq "time") { #- ukazka formatovani time
         print "<option>";
         printE(translate("examples"));
         print "</option>";
      }
      #- ukazka formatu konec
      if($type ne "") {
         print "</select>";
         print "<br/>";
         print "<input";
               printA("name","col_format");
               printA("style","width: 100%");
               printA("type","text");
               printA("value","");
               print "/>";
         print "</p>";
         if($type eq "number") {
            print "<p>";
            printE(translate("Show sum:"));
            printE(" ");
            print "<input";
                  printA("name","col_summary_select");
                  printA("type","checkbox");
                  print "/>";
            print "</p>";
         }
      }
      print "<p>";
      printE(translate("Show column:"));
      printE(" ");
      print "<input";
            printA("name","col_show");
            printA("type","checkbox");
            print "/>";
      print "</p>";
      print "<p>";
      print "<select";
            printA("name","col_chosen");
            print ">";
      foreach my $chosen (0,1,2) {
         print "<option";
               printA("value",$chosen);
               printA("class","chosen$chosen");
               print ">";
         printE(translate("colored mark of column"));
         print "</option>";
      }
      print "</select>";
      print "</p>";
      print "<p>";
      print "<input";
            printA("type","submit");
            printA("value",translate("Ok"));
            print "/>";
      print "&#160;";
      print "<input";
            printA("type","button");
            printA("value",translate("Cancel"));
            printA("onclick","window_format.style.display=\"none\"");
            print "/>";
      print "</p>";
      print "</div>";
      print "</form>";
      if($type ne "") {
         print "<p>";
         printE(translate("More about formating:"));
         print "</p>";
         print "<ul>";
         print "<li>";
         print "<a";
               printA("href","http://msdn.microsoft.com/library/psdk/xmlsdk/xmld5rg2.htm");
               printA("target","_blank");
               print ">";
         printE(translate("formating of number"));
         print "</a>";
         print "</li>";
         print "<li>";
         print "<a";
               printA("href","http://msdn.microsoft.com/library/psdk/xmlsdk/xmld7691.htm");
               printA("target","_blank");
               print ">";
         printE(translate("formating of date"));
         print "</a>";
         print "</li>";
         print "<li>";
         print "<a";
               printA("href","http://msdn.microsoft.com/library/psdk/xmlsdk/xmld7rj9.htm");
               printA("target","_blank");
               print ">";
         printE(translate("formating of time"));
         print "</a>";
         print "</li>";
         print "</ul>";
      }
      print "</window>";
   }
}
## presun tyhle funkce jinam - KONEC


#--------------- Tisk hodnot promenych ve vystupu
sub print_variables {
   my ($pkg_p,$variables)=@_;
   if(defined($variables)) {
      print "<p>";
      for(my $i=0;$i<=$#$variables;++$i) {
         print "$$variables[$i][0]: $$variables[$i][1]";
         print ", " if($i<$#$variables);
      }
      print "</p>";
   }
}

#-------------- Obdrzeni promenych z formulare
sub form_variables_get {
   my @names=$query->param;
   my @variables;
   foreach my $name (@names) {
      if($name=~/^VAR_(.+)$/) {
         push(@variables, [$1,$query->param($name)]);
      }
   }
   return \@variables;
}

## funkce nize by to chtelo nejak skonzistentnit a vse pekne pojmenovat

#-------------- Funkce urcujici XML typ polozky
# musi byt zalozena na data_type_number, jelikoz jsou vraceny sloupce, ktere jsou slouceninou ruznych sloupcu nebo po aplikaci funkci
sub field_type {
   my ($pkg_p,$data_type_number)=@_;
   my @type_info=$dbh->type_info($data_type_number);
   my $data_type_string=$type_info[0]{TYPE_NAME};
   my $data_type_string_xml=$pkg->field_type_by_sqltype($data_type_string);
   return $data_type_string_xml;
}

#-------------- Funkce urcujici XML typ polozky na zaklade typu MySQL
sub field_type_by_sqltype {
   my ($pkg_p,$data_type_string)=@_;
   my %data_types_string_xml=(
      "tinyint" => "number",
      "smallint" => "number",
      "mediumint" => "number",
      "int" => "number",
      "integer" => "number",
      "bigint" => "number",
      "float" => "number",
      "double" => "number",
      "double precision" => "number",
      "real" => "number",
      "decimal" => "number",
      "numeric" => "number",
      "date" => "date",
      "datetime" => "dateTime",
      "timestamp" => "dateTime",   # podporuji jen timestamp ve tvaru YYYYMMDDHHMMSS
      "time" => "time"
   );
   my $data_type_string_xml="$data_types_string_xml{$data_type_string}";
   return $data_type_string_xml;
}

#-------------- Funkce urcujici XML typ polozky na zaklade celeho jmena sloupce
sub field_sqltype_by_col_fullname {
   my ($pkg_p,$col_fullname)=@_;
   my $field_def=$pkg->field_def($col_fullname);
   my $data_type_string=$$field_def{Type};
   $data_type_string=~s/\((\d+),{0,1}\d*\)$//;
   return $data_type_string;
}

#-------------- Funkce urcujici XML typ polozky
sub field_length {
   my ($pkg_p,$col_fullname)=@_;
   my $length;
   if(defined($col_fullname)) {
      my $field_def=$pkg->field_def($col_fullname);
      if($$field_def{Type}=~/\((\d+),{0,1}\d*\)$/) {
         $length=$1;
      }
   }
   return $length;
}

#-------------- Funkce popisujici definici sloupce v tabulce
sub field_def {
   my ($pkg_p,$col_fullname)=@_;
   my ($database,$table,$col)=split(/\./,$col_fullname);
   my $sth=$dbh->prepare("show columns from $database.$table like ?");
   $sth->execute($col);
   my $ref=$sth->fetchrow_hashref;
   my $field_def=$ref;
   $sth->finish;
   return $field_def;
}

#-------------- Funkce popisujici definici sloupce v tabulce - vraci retezec
sub field_def_str {
   my ($pkg_p,$col_fullname)=@_;
   my $field_def_str;
   if($col_fullname!~/^([^\.]+)\.([^\.]+)\.(\*)$/) {
      my $field_def=$pkg->field_def($col_fullname);
      $field_def_str="$$field_def{Field} $$field_def{Type}";
      if(defined($$field_def{Default})) {
         $field_def_str.=" DEFAULT '$$field_def{Default}'";
      }
      if($$field_def{Null} ne "YES") {
         $field_def_str.=" NOT NULL";
      }
   }
   return $field_def_str;
}

#----- Funkce prevalcuje nektere hodnoty v param, pokud prisli primo GET ci POST metodou v pozadavku
sub update_param_by_GET_or_POST {
   my ($pkg_p,$param)=@_;
   if(defined($query->param("link"))) {
      $$param{link}=$query->param("link");
   }
   if(defined($query->param("query_type"))) {
      $$param{query_type}=$query->param("query_type");
   }
   return $param;
}

#-------------- Funkce urcujici typ vystupu v zavislosti na prohlizeci a typu dotazu
sub query_type_auto {
   my ($pkg_p,$query_string)=@_;
   my ($query_type);
   if($ENV{HTTP_USER_AGENT}=~/MSIE [56789]/ and not $ENV{HTTP_USER_AGENT}=~/Windows 3\./) {
      $query_type="xml_table";
   }
   else {
      $query_type="table";
   }
   return $query_type;
}

#----------- Vrati uzivatele, ktery dotaz nebo slozku vytvoril
sub create_user {
   my ($pkg_p,$database,$folder,$query_name)=@_;
   my $create_user;
   if(length($query_name)) {
      # odstraneni pripadneho " (ungroup)" na konci jmena dotazu - tvurce zjistuji na ne (ungoup) jmeno dotazu
      while($query_name=~s/\Q$maccess_query_name_ungroup\E$//) {
      }
      my $query_string="
         select
            create_user
         from
            Query
         where
            Query.database_name=? and
            Query.folder_name=? and
            Query.query_name=?
      ";
      my $sth=$dbh->prepare($query_string);
      my $rv=$sth->execute($database,"$folder",$query_name);
      my $ref=$sth->fetchrow_hashref;
      $create_user=$$ref{create_user};
      my $rc=$sth->finish;
   }
   elsif(length($folder)) {
      my $query_string="
         select
            create_user
         from
            Query_folder
         where
            Query_folder.database_name=? and
            Query_folder.folder_name=?
      ";
      my $sth=$dbh->prepare($query_string);
      my $rv=$sth->execute($database,"$folder");
      my $ref=$sth->fetchrow_hashref;
      $create_user=$$ref{create_user};
      my $rc=$sth->finish;
   }
   else {
      $create_user=$maccess_power_user;
   }
   return $create_user;
}

#----------- Funkce slouzici k tisku padacich menu
sub print_option {
   my ($pkg_p,$option_val,$option_text,$option_class,$option_val_selected)=@_;
   for(my $i=0; $i<=$#$option_val; ++$i) {
      print "<option";
         printA("value",$$option_val[$i]);
         printA("class",$$option_class[$i]) if(defined($$option_class[$i]));
         if($option_val_selected eq $$option_val[$i]) {
            print " selected=\"selected\"";
         }
      print ">";
      printE($$option_text[$i]);
      print "</option>";
   }
}

#----------- Funkce slouzici k tisku padaciho meny z vyberem typu zobrazeni
sub print_select_query_type {
   my ($pkg_p,$default)=@_;
   print "<select";
         printA("name","query_type");
         print ">";
   $pkg->print_option(["auto","txt","table","xml_table","xml_raw","excel","file","graph_bars","graph_bars_sum","graph_pie","graph_area", "graph_lines","graph_linespoints","map_Europe", "update_add"],
                      [
                         translate("auto"),
                         translate("txt"),
                         translate("table"),
                         translate("xml table"),
                         translate("xml raw"),
                         translate("Excel 97"),
                         translate("file ~/tmp/maccess.txt"),
                         translate("graph - bars"),
                         translate("graph - bars sum"),
                         translate("graph - pie"),
                         translate("graph - area"),
                         translate("graph - lines"),
                         translate("graph - linespoints"),
                         translate("map - Europe"),
                         translate("add row")
                      ],
                      [],
                      $default
                      );
   print "</select>";
}





#-============= Funkce pro praci se slozkami ==================================-#
#--------------- Funkce vracejici seznam slozek ---------------------#
sub query_folders {
   my ($pkg_p,$database,$folder)=@_;
   my (@query_folders);
   my $query_string="
      select
         Query_folder.folder_name
      from
         Query_folder
      where
         Query_folder.database_name=? and
         Query_folder.supfolder_name like ?
      order by
         Query_folder.folder_name asc
   ";
   my $sth=$dbh->prepare($query_string);
   my $rv=$sth->execute($database,"$folder");
   push @query_folders, "";
   while(my $ref=$sth->fetchrow_hashref) {
      push @query_folders, $$ref{folder_name};
   }
   my $rc=$sth->finish;
   return @query_folders;
}






#-====== Sessions ===============-#
#-- Zaznamenani udaju v param do souboru ---------
sub param_save {
   my ($pkg_p,$param)=@_;
   my %session;
   tie %session, "Apache::Session::File", undef, {
      Directory => $maccess_tmp_abspath,
      LockDirectory   => $maccess_tmp_abspath
   };
   my $id=$session{_session_id};
   $session{param}=$param;
   untie %session;
   return $id;
}
#-- Nacteni udaju ze souboru do param ------------
sub param_load {
   my ($pkg_p,$id)=@_;
   my %session;
   eval { # blok eval zajistuje, ze pokud neexistuje session $id, tak nedojde ke zhrouceni programu
      tie %session, "Apache::Session::File", $id, {
         Directory => $maccess_tmp_abspath,
         LockDirectory   => $maccess_tmp_abspath
      };
   };
   my $param=$session{param};
   untie %session;
   return $param;
}






#-====== Zakladni funkce Maccessu pro zjistovani informaci o DB a tabulkach ======-#
#-- Overeni pristupu k databazim a ziskani user_sql a pass_sql
sub user_sql {
   my ($pkg_p,$remote_user)=@_;
   my $sth=$dbh->prepare("select password from Passwd where user=?");
   $sth->execute($remote_user);
   my $ref=$sth->fetchrow_arrayref;
   my ($user_sql, $pass_sql)=($remote_user, $$ref[0]);
   $sth->finish;
   return ($user_sql, $pass_sql);
}

#-- Kdo se do Maccessu prihlasil
sub get_remote_user {
   my $remote_user;
   if($ENV{REQUEST_URI}=~/^\Q$maccess_path\E/) {
      $remote_user=$ENV{REMOTE_USER};
   }
   else {
      require POSIX;
      my $uid=POSIX::geteuid;
      my @passwd=getpwuid $uid;
      $remote_user=$passwd[0];
   }
   return $remote_user;
}

#-- Funkce vracejici pole se seznamem databazi na ktere ma uzivatel pravo
sub databases {
   my ($pkg_p,$remote_user)=@_;
   my (@databases);
   # user - predpokladam, ze uzivatel ma v tabulce user jen jeden zaznam
   my $sth=$dbh->prepare("select Select_priv from mysql.user where User=?");
   $sth->execute($remote_user);
   my $ref=$sth->fetchrow_arrayref;
   my $select_priv=$$ref[0];
   $sth->finish;
   # pokud ma uzivatel select pravo na vsechny DB
   if($select_priv eq "Y") {
      my $sth=$dbh->prepare("show databases");
      $sth->execute;
      while(my $ref=$sth->fetchrow_arrayref) {
         push @databases, $$ref[0];
      }
      $sth->finish;
   }
   # pokud nema uzivatel select pravo na vsechny DB
   elsif($select_priv eq "N") {
      # db - neuvazuji mozne ruzne zaznamy uzivatele pro ruzne Host
      my $sth=$dbh->prepare("select Db from mysql.db where User=?");
      $sth->execute($remote_user);
      while(my $ref=$sth->fetchrow_arrayref) {
         push @databases, $$ref[0] if(!grep(/^\Q$$ref[0]\E$/, @databases));
      }
      $sth->finish;
      # tables_priv - neuvazuji mozne ruzne zaznamy uzivatele pro ruzne Host
      my $sth=$dbh->prepare("select Db from mysql.tables_priv where User=?");
      $sth->execute($remote_user);
      while(my $ref=$sth->fetchrow_arrayref) {
         push @databases, $$ref[0] if(!grep(/^\Q$$ref[0]\E$/, @databases));
      }
      $sth->finish;
   }
   # pokud uzivatel nema vubec zadna prava
   else {
      die("You have not rights!");
   }
   return sort @databases;
}

#-- Funkce vracejici pole se seznamem tabulek na ktere ma dany uzivatel nejake pravo
sub tables {
   my ($pkg_p,$database,$remote_user)=@_;
   my ($user,$pass)=$pkg->user_sql($pkg->get_remote_user);
   my $dbh_user=DBI->connect("DBI:$driver:$database:$hostname",$user,$pass);
   my @tables=$dbh_user->func('_ListTables');
   $dbh_user->disconnect;
   return sort @tables;
}

#-------------- Funkce zjistujici existenci tabulky (pokud uzivatel na ni nema pravo, je to jakoby neexistovala)
sub table_exist {
   my ($pkg_p,$database,$table)=@_;
   my @tables=$pkg->tables($database,$table);
   return grep(/^\Q$table\E$/,@tables);
}

#-------------- Funkce zjistujici vracejici help pro Polozky, Tabulky a Databaze
sub database_help {
   my ($pkg_p,$database,$table,$field)=@_;
   my @values;
   my $query_string="
      select
         Database_help.help
      from
         Database_help
      where
         Database_help.database_name=? and
         Database_help.table_name=? and
         Database_help.field_name=?
   ";
   my $sth=$dbh->prepare($query_string);
   $sth->execute($database,"$table","$field");
   my $ref=$sth->fetchrow_hashref;
   my $help_text=$$ref{help};
   $sth->finish;
   return $help_text;
}

return 1;
