package Maccess_locale;

my $pkg="Maccess_locale";

use Exporter ();
@ISA=qw(Exporter);
@EXPORT=qw(translate);

use Maccess_db;
use CGI;

my $query=new CGI;

my $dbh=Maccess_db->maccess_dbh;

#- zjisteni pouzivaneho jazyka
my $language;
if(defined($query->param("language"))) {
   $language=$query->param("language");
}
elsif(defined($query->cookie(-name=>"language"))) {
   $language=$query->cookie(-name=>"language");
}
else {
   # Default language
   $language="en";
}

#- zjisteni pouzivane znakove sady
my $charset;
if(defined($query->param("charset"))) {
   $charset=$query->param("charset");
}
elsif(defined($query->cookie(-name=>"charset"))) {
   $charset=$query->cookie(-name=>"charset");
}
else {
   # Default MySQL charset
   $charset="iso-8859-1";
}

#- funkce vraci nastaveny jazyk
sub language { return $language; }

#- funkce vraci seznam jazyku podporovanych Maccessem
sub language_supported { return ( "cz" => "Czech", "en" => "English" ); }

#- funkce vraci nastavenou znakovou sadu
sub charset { return $charset; }

#- funkce vraci seznam jazyku podporovanych Maccessem
sub charset_supported { return ( "iso-8859-1" => "iso-8859-1", "iso-8859-2" => "iso-8859-2", "windows-1250" => "windows-1250" ); }

#- funkce zajistujici konverzi jmen znakovych sad pro knihovnu Unicode::Map8
sub charset_pkgUnicode { return ( "UTF-8" => "UTF-8", "iso-8859-1" => "ISO_8859-1", "iso-8859-2" => "ISO_8859-2", "windows-1250" => "cp1250" ); }

#- funkce zajistujici preklad hlasek Maccessu na nastaveny jazyk
sub translate {
   my ($text_for_translation,@values)=@_;
   my $translation;
   if($language ne "en") {
      my $query_string="
         select
            Language_$language.translation
         from
            Language_$language
         where
            Language_$language.text_for_translation=?
      ";
      my $sth=$dbh->prepare($query_string);
      my $rv=$sth->execute($text_for_translation);
      if($sth->rows) {
         my $ref=$sth->fetchrow_hashref;
         $translation=$$ref{translation};
      }
      else {
         $translation=$text_for_translation;
      }
      my $rc=$sth->finish;
   }
   else {
      $translation=$text_for_translation;
   }
   # doplneni @values do $translation na mista :0, :1, ...
   my $translation_and_values;
   foreach my $translation_substr (split(/(:\d)/,$translation)) {
      if($translation_substr=~/^:(\d)$/) {
         $translation_and_values.=$values[$1];
      }
      else {
         $translation_and_values.=$translation_substr;
      }
   }
   return $translation_and_values;
}

return 1;
